#!/usr/local/bin/bash
umask 002
unset PRODUCTS
. /sdss/ups/etc/setups.sh

# Following exported for use in sdssmake environment
export upsRoot=/sdss/ups
export upsSetup=/sdss/ups/etc/setups.sh
export newVers=v2_1_2b
export flavDir=Linux-2-4-2-3-2

cd Linux-2-4-2-3-2
echo "---------------------------------------------------------------"
date
echo -e "\nBegin cvs export -r v2_1_2b fslalib"
setup sdsscvs
cvs export -r v2_1_2b fslalib
rc=$?
if (( rc != 0 ))
then
    echo "error: \`cvs export -r v2_1_2b fslalib' exited $rc"
    exit 1
fi
date
echo "Ended cvs export -r v2_1_2b fslalib"
buildProds=(sdsstools tex)
echo "---------------------------------------------------------------"
echo -e "\nBegin setup of products required for building"
for item in ${buildProds[@]}
do
    echo "Begin \`setup $item'"
    setup $item
    rc=$?
    if (( rc != 0 ))
    then
        echo "error: \`setup $item' exited $rc"
        exit 1
    echo "Ended \`setup $item'"
    fi
done
date
echo "Ended setup of products required for building"
echo "---------------------------------------------------------------"
echo "native compiler desired (default), will unset gcc if already set"
[ ! -z "$SETUP_GCC" ] && unsetup gcc
date
echo "Using \"default\" gcc = $(which gcc)"
echo "Completed \`unsetup gcc' if previously set"
echo "---------------------------------------------------------------"
echo "Begin setup dependent product \`slalib v2_1_2b  -j'"
setup slalib v2_1_2b  -j
rc=$?
if (( rc != 0 ))
then
    echo "error: \`setup slalib v2_1_2b  -j' exited $rc"
    exit 1
fi
echo "Ended \`setup slalib v2_1_2b  -j'"
echo "IDL_PATH=$IDL_PATH"
echo "---------------------------------------------------------------"
echo -e "\nBegin setup  -r /usrdevel/lnx9/jhendry/products/build/Linux-2-4-2-3-2/fslalib fslalib "
setup  -r /usrdevel/lnx9/jhendry/products/build/Linux-2-4-2-3-2/fslalib fslalib 
rc=$?
if (( rc != 0 ))
then
    echo "error: \`setup  -r /usrdevel/lnx9/jhendry/products/build/Linux-2-4-2-3-2/fslalib fslalib ' exited $rc"
    exit 1
fi
echo "Ended \`setup  -r /usrdevel/lnx9/jhendry/products/build/Linux-2-4-2-3-2/fslalib fslalib '"
echo "---------------------------------------------------------------"
echo -e "\nBegin setup tex"
setup tex
rc=$?
if (( rc != 0 ))
then
    echo "error: \`setup tex' exited $rc"
    exit 1
fi
echo "Completed \`setup tex'"
if (( ${#SETUP_POSTGRES} > 0 ))
then
    unsetup postgres
fi
echo "---------------------------------------------------------------"
date
echo "Build for product=fslalib cvsTag=v2_1_2b declareVersion=v2_1_2b"
echo "fslalib -r /usrdevel/lnx9/jhendry/products/build/Linux-2-4-2-3-2/fslalib"
echo "slalib v2_1_2b"
echo -e "\nBuild with this environment:\n"
set | grep "_DIR" | sort
echo "---------------------------------------------------------------"
echo -e "\nTEXINPUTS=$TEXINPUTS"
echo -e "\n$PATH"
echo "---------------------------------------------------------------"
export FSLALIB_INSTALL_DIR=/sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
echo "Using FSLALIB_INSTALL_DIR=/sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2"
echo "---------------------------------------------------------------"
date
if [ ! -f fslalib/Makefile ]
then
    if [ -f fslalib/Makefile.in -a -f fslalib/configure ]
    then
        cd fslalib
        ./configure
        cd ..
    else
        echo "error: no Makefile.in or configure script"
        exit 2
    fi
fi
echo "Begin sdssmake -fullopt all"
cd fslalib
pwd
eval sdssmake -fullopt all
rc=$?
if (( rc != 0 ))
then
    echo "error: \`sdssmake -fullopt all' exited $rc"
    exit 1
fi
cd ..
echo "Ended sdssmake -fullopt all"
echo "---------------------------------------------------------------"
date
echo "Begin sdssmake install"
export FSLALIB_DIR=/sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
echo "FSLALIB is $FSLALIB"
echo -e "Making product installation directory"
mkdir -m 775 -p /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
cd fslalib
sdssmake install
rc=$?
if (( rc != 0 ))
then
    echo "error: \`sdssmake install' exited $rc"
    exit 1
fi
cd ..
echo "Ended sdssmake install"
upsDclComArgs="fslalib v2_1_2b -c -f Linux+2.4-2.3.2 -r fslalib/v2_1_2b/Linux-2-4-2-3-2 -z /sdss/ups/db"
if [ -f fslalib/ups/fslalib.table ]
then
    upsTblArgs="-m fslalib.table -M ups"
else
    # product ups directory has not table file, copying from earlier version
    Gargs="-r /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2 -c fslalib v2_1_2b -m v2_1_2b.table"
    ups copy -W -f Linux+2.4-2.3.2 -G "$Gargs" fslalib v2_1_2a
    # remove all -z flags from copied table file
    perl -p -i -e 's/\b -z .*\b//g' /sdss/ups/db/fslalib/v2_1_2b.table
    upsTblArgs="-m v2_1_2b.table"
fi
echo "Begin \`ups declare $upsDclComArgs $upsTblArgs'"
ups declare $upsDclComArgs $upsTblArgs
echo "Ended \`ups declare $upsDclComArgs $upsTblArgs'"
chmod g+w /sdss/ups/prd/fslalib/v2_1_2b
chown jhendry.products /sdss/ups/prd/fslalib/v2_1_2b
echo -e "\nSeal the product"
{
    echo "Seal for FSLALIB"
    date
    echo "=== _DIR environment"
    set | grep "_DIR" | sort
    for _dir in bin etc lib
    do
        if [ -d /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2/$_dir ]
        then
            for _f in /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2/$_dir/*
            do
                if [ -f $_f ]
                then
                    echo "=== sum for $_dir/*"
                    sum /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2/$_dir/*
                    break
                fi
            done
        fi
    done
    echo "=== ls -lR for FSLALIB"
    chmod -R a-w /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
    ls -lR /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
} > seal.fslalib.v2_1_2b.v2_1_2b.Linux+2.4-2.3.2
chmod +w /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
cp seal.fslalib.v2_1_2b.v2_1_2b.Linux+2.4-2.3.2 /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
chgrp -R products /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
chmod a-w /sdss/ups/prd/fslalib/v2_1_2b/Linux-2-4-2-3-2
echo "ALL DONE"
