#!/usr/local/bin/bash
umask 002
unset PRODUCTS
source /sdss/ups/etc/setups.sh

# Following exported for Info and/or use in sdssmake environment
export upsRoot=/sdss/ups
export upsSetup=/sdss/ups/etc/setups.sh
export newVers=v3_6_1
export unameDcl=Linux
export unameDir=Linux
export buildDir=/usrdevel/lnx1/jhendry/products/build/Linux/ftcl
mkdir -m 775 -p Linux
cd Linux
if [ -d /usrdevel/lnx1/jhendry/products/build/Linux/ftcl ]
then
    echo -e "Running bg removal of prior cvs export of ftcl"
    mv /usrdevel/lnx1/jhendry/products/build/Linux/ftcl /usrdevel/lnx1/jhendry/products/build/Linux/ftcl.REMOVING
    rm -rf /usrdevel/lnx1/jhendry/products/build/Linux/ftcl.REMOVING >& /dev/null &
fi
echo "---------------------------------------------------------------"
date
echo -e "\nBegin cvs export -r v3_6_1 ftcl"
setup sdsscvs
cvs export -r v3_6_1 ftcl
rc=$?
if (( rc != 0 ))
then
    echo "error: \`cvs export -r v3_6_1 ftcl' exited $rc"
    exit 1
fi
date
echo "Ended cvs export -r v3_6_1 ftcl"
echo "---------------------------------------------------------------"
echo -e "native compiler desired (default)"
if (( ${#SETUP_GCC} ))
then
    echo -en ", un-setting $SETUP_GCC ..."
    unsetup $SETUP_GCC
    echo -e " DONE"
fi
echo -e "Using $(which gcc)  Version: $(gcc --version | head -1)"
echo "---------------------------------------------------------------"
echo -e "\nBegin setup  -r /usrdevel/lnx1/jhendry/products/build/Linux/ftcl ftcl "
setup  -r /usrdevel/lnx1/jhendry/products/build/Linux/ftcl ftcl 
rc=$?
if (( rc != 0 ))
then
    echo "error: \`setup  -r /usrdevel/lnx1/jhendry/products/build/Linux/ftcl ftcl ' exited $rc"
    exit 1
fi
echo "Ended \`setup  -r /usrdevel/lnx1/jhendry/products/build/Linux/ftcl ftcl '"
echo "---------------------------------------------------------------"
echo "Begin setup dependent product \`tclx v7_4adfa_3  -j'"
prev_IDL_PATH=$IDL_PATH
setup tclx v7_4adfa_3  -j
rc=$?
if (( rc != 0 ))
then
    echo "error: \`setup tclx v7_4adfa_3  -j' exited $rc"
    exit 1
fi
if [ $IDL_PATH != $prev_IDL_PATH ]
then
    echo -e "IDL_PATH has been modified"
    echo -e "old IDL_PATH=$prev_IDL_PATH"
    echo -e "new IDL_PATH=$IDL_PATH"
fi
echo "Ended \`setup tclx v7_4adfa_3  -j'"
buildProds=(sdsstools tex)
echo "---------------------------------------------------------------"
echo -e "\nBegin setup of products required for building"
for item in ${buildProds[@]}
do
    echo "Begin \`setup $item'"
    setup $item
    rc=$?
    if (( rc != 0 ))
    then
        echo "error: \`setup $item' exited $rc"
        exit 1
    echo "Ended \`setup $item'"
    fi
done
date
echo "Ended setup of products required for building"
if (( ${#SETUP_POSTGRES} ))
then
    unsetup $SETUP_POSTGRES
fi
echo "---------------------------------------------------------------"
date
echo "Build for product=ftcl cvsTag=v3_6_1 declareVersion=v3_6_1 "
echo "ftcl -r /usrdevel/lnx1/jhendry/products/build/Linux/ftcl"
echo "Dependencies of ftcl as listed in ftcl.par (for information only)"
echo "	tclx v7_4adfa_3"
echo -e "\n---------------------------------------------------------------\nBuild with this environment:\n"
set | grep "_DIR"
echo -e "---------------------------------------------------------------"
echo -e "\nTEXINPUTS=$TEXINPUTS"
pathParts=( ${PATH//:/ } )
echo -e "\n---------------------------------------------------------------\nPATH contains ${#pathParts[@]} components: (${#PATH} bytes)"
unset idx
while (( idx < ${#pathParts[@]} ))
do
    printf "  %3d: %s\n" $(( idx + 1 )) ${pathParts[$(( idx ))]}
    (( ++idx ))
done
echo "---------------------------------------------------------------"
export FTCL_INSTALL_DIR=/sdss/ups/prd/ftcl/v3_6_1/Linux
echo "Using FTCL_INSTALL_DIR=/sdss/ups/prd/ftcl/v3_6_1/Linux"
echo "---------------------------------------------------------------"
date
if [ ! -f ftcl/Makefile ]
then
    if [ -f ftcl/Makefile.in -a -f ftcl/configure ]
    then
        cd ftcl
        ./configure --prefix=/sdss/ups/prd/ftcl/v3_6_1/Linux
        cd ..
    else
        echo "error: no Makefile.in or configure script"
        exit 2
    fi
fi
echo "Begin sdssmake -m32 -fullopt all"
cd ftcl
echo -e "Now in $(pwd)"
eval sdssmake -m32 -fullopt all
rc=$?
if (( rc != 0 ))
then
    echo "error: \`sdssmake -m32 -fullopt all' exited $rc"
    exit 1
fi
cd ..
echo "Ended sdssmake -m32 -fullopt all"
echo "---------------------------------------------------------------"
date
echo "Begin sdssmake install"
export FTCL_DIR=/sdss/ups/prd/ftcl/v3_6_1/Linux
echo -e "Making product installation directory: /sdss/ups/prd/ftcl/v3_6_1/Linux"
mkdir -m 775 -p /sdss/ups/prd/ftcl/v3_6_1/Linux
cd ftcl
sdssmake install
rc=$?
if (( rc != 0 ))
then
    echo "error: \`sdssmake install' exited $rc"
    exit 1
fi
cd ..
echo "Ended sdssmake install"
upsDclComArgs="ftcl v3_6_1 -c -f Linux  -r ftcl/v3_6_1/Linux -z /sdss/ups/db"
if [ -f ftcl/ups/ftcl.table ]
then
    upsTblArgs="-m ftcl.table -M ups"
else
    # product ups directory has no table file, copying from earlier version
    Gargs="-r /sdss/ups/prd/ftcl/v3_6_1/Linux -c ftcl v3_6_1 -m v3_6_1.table "
    ups copy -W -f Linux  -G "$Gargs" ftcl v3_6
    # remove all -z flags from copied table file
    perl -p -i -e 's/\b -z .*\b//g' /sdss/ups/db/ftcl/v3_6_1.table
    upsTblArgs="-m v3_6_1.table"
fi
echo "Begin \`ups declare $upsDclComArgs $upsTblArgs'"
ups declare $upsDclComArgs $upsTblArgs
echo "Ended \`ups declare $upsDclComArgs $upsTblArgs'"
chmod g+w /sdss/ups/prd/ftcl/v3_6_1
chown jhendry.products /sdss/ups/prd/ftcl/v3_6_1
echo -e "\nSeal the product"
chmod -R a-w /sdss/ups/prd/ftcl/v3_6_1/Linux
{
    echo "Seal for FTCL at $(date)"
    echo -e "====== PRODUCT VERSIONS USED (in environment) ======"
    set | grep _DIR
    echo -e "\n====== CHECKSUMS (selected sub directories) ======"
    for dir in $(find ftcl -mindepth 1 -type d | egrep -v "^ftcl/(doc|examples|tests?)/" | sort)
    do
        echo -e " ------ sub directory $dir/ ------"
        sum $(find $dir -type f | sort)
    done
    echo -e "\n====== ls -lR for FTCL ======"
    ls -lR /sdss/ups/prd/ftcl/v3_6_1/Linux
} > ftcl.v3_6_1.v3_6_1.Linux.seal
gzip ftcl.v3_6_1.v3_6_1.Linux.seal
chmod ug+w /sdss/ups/prd/ftcl/v3_6_1/Linux
cp ftcl.v3_6_1.v3_6_1.Linux.seal.gz /sdss/ups/prd/ftcl/v3_6_1/Linux/
chmod a-w /sdss/ups/prd/ftcl/v3_6_1/Linux
chgrp -R products /sdss/ups/prd/ftcl/v3_6_1/Linux
echo "ALL DONE at $(date)"
