proc chainMatch {chain1 chain2} {
   upvar 1 x1chain x1chain
   upvar 1 y1chain y1chain
   upvar 1 x2chain x2chain
   upvar 1 y2chain y2chain
   set x1chain ""
   set y1chain ""
   set var1chain ""
   linkInit $chain1 iter
   for {set i 0} {$i < [chainSize $chain1]} {incr i} {
	set handle [linkNext iter]
	lappend x1chain [handleShow $handle.row]
	lappend y1chain [handleShow $handle.col]
	lappend var1chain .2
	}
   linkNext iter
   set x2chain ""
   set y2chain ""
   set var2chain ""
   linkInit $chain2 iter
   for {set i 0} {$i < [chainSize $chain2]} {incr i} {
	set handle [linkNext iter]
	lappend x2chain [handleShow $handle.row]
	lappend y2chain [handleShow $handle.col]
	lappend var2chain .2
	}
   linkNext iter
   set coeffchain [triMatch $x1chain $y1chain $var1chain $x2chain $y2chain $var2chain]
   echo $coeffchain
   chainTrans $x1chain $y1chain $x2chain $y2chain $coeffchain
#All right, let's make a merged object list with all the matches
   set type1 [chainTypeDefine $chain1]
   set type2 [chainTypeDefine $chain2]
   set newType MRG_${type1}_${type2}
   set alltypes [typesList]
   if {[lindex $alltypes $newtype] == -1} then {
	set schema(1) "$newtype STRUCT 8 2"
	set schemaElem(1)(1) "item1 $type1 1 NULL 0"
	set schemaElem(1)(2) "item2 $type2 1 NULL 0"
	schemaDefine schema schemaElem
	unset schema
	unset schemaElem
	}
   
   return
   }

proc chainTrans {xorgchain yorgchain xchain ychain coeffchain} {
   set nelem [llength $xorgchain]
   echo "First chain"
   for {set i 0} {$i < $nelem} {incr i} {
	set x [lindex $xorgchain $i]
	set y [lindex $yorgchain $i]
	echo [format "%8.2f%8.2f" $x $y]
	}
   set a [lindex $coeffchain 0]
   set b [lindex $coeffchain 1]
   set c [lindex $coeffchain 2]
   set d [lindex $coeffchain 3]
   set e [lindex $coeffchain 4]
   set f [lindex $coeffchain 5]
   set nelem [llength $xchain]
   echo "Second chain"
   echo "   Original      Transformed "
   upvar 2 xtranschain xtranschain
   upvar 2 ytranschain ytranschain
   set xtranschain ""
   set ytranschain ""
   for {set i 0} {$i < $nelem} {incr i} {
	set x [lindex $xchain $i]
	set y [lindex $ychain $i]
	set xtrans [expr ($x)*($a)+($y)*($b)+($c)]
	set ytrans [expr ($x)*($e)+($y)*($d)+($f)]
	echo [format "%8.2f%8.2f   %8.2f%8.2f" $x $y \
		$xtrans $ytrans]
	lappend xtranschain $xtrans
	lappend ytranschain $ytrans
	}
   }
