#Operate on a frame with a constant
proc +con {reg con} {
   regAddWithDbl $reg $con
   return
   }

proc -con {reg con} {
   regAddWithDbl $reg [expr -1*$con]
   return
   }

proc *con {reg con} {
   regMultiplyWithDbl $reg $con
   return
   }

proc /con {reg con} {
   if {$con == 0.} {error "Can't divide by 0"}
   regMultiplyWithDbl $reg [expr 1./$con]
   return
   }

#########################################################################
#Operate on a frame with a column vector. Except astrotools calls this
#a row vector (1 row by n columns)

proc +col {reg1 reg2} {
   regAddRow $reg1 $reg2
   return
   }

proc -col {reg1 reg2} {
   regSubRow $reg1 $reg2
   return
   }

#We divide product by scale
proc *col {reg1 reg2 {scale 8000.}} {
   regMultWithRow $reg1 $reg2 -scale $scale
   return
   }

#We multiply division by scale
proc /col {reg1 reg2 {scale 8000.}} {
   regDivByRow $reg1 $reg2 -scale $scale
   return
   }

#########################################################################
#Operate on a frame with a row vector. Except astrotools calls this
#a column vector (1 row by n columns)

proc +row {reg1 reg2} {
   regAddCol $reg1 $reg2
   return
   }

proc -row {reg1 reg2} {
   regSubCol $reg1 $reg2
   return
   }

#We divide product by scale
proc *row {reg1 reg2 {scale 8000.}} {
   regMultWithRow $reg1 $reg2 -scale $scale
   return
   }

#We multiply division by scale
proc /row {reg1 reg2 {scale 8000.}} {
   regDivByRow $reg1 $reg2 -scale $scale
   return
   }

########################################################################
#File operations.
proc +file {reg1 reg2} {
   regAdd $reg1 $reg2
   return
   }

proc -file {reg1 reg2} {
   regSubtract $reg1 $reg2
   return
   }

#We divide product by scale
proc *file {reg1 reg2 {scale 8000.}} {
   regMultiply $reg1 $reg2 -scale $scale
   return
   }

#We multiply division by scale
proc /file {reg1 reg2 {scale 8000.}} {
   regDivide $reg1 $reg2 -scale $scale
   return
   }

