#Fit sech^2 to existing profile.
proc funcFit {} {
   imgGlobals
   if {![info exists img(profile)]} {
	echo Need a profile
	return
	}
   if {![info exists img(sky)]} {
	echo Need some sky
	return
	}

#Need to get a priori FWHM, peak intensity
   set nstep [chainSize $img(profile)]
   if {$nstep <= 0} return
   chainEach hndl $img(profile) {
	set cnts [expr [exprGet $hndl.cnts] - $img(sky)]
	set rad [exprGet $hndl.rad]
	if {$rad < 0} continue
	if {$rad == 0} {
	   set peak $cnts
	   continue
	   }
	if {$cnts < $peak/2.} {
	   set fwhm [expr 2. * $rad]
	   break
	   }
	}
   if {![info exists fwhm]} {
	set fwhm [expr 2*$nstep]
	}
   echo peak $peak fwhm $fwhm
   while {1} {
	puts stdout "Iterate? " nonewline
	flush stdout
	set line [gets stdin]
	set yn [lindex $line 0]
	set fract [lindex $line 1]
	if {$yn == "y"} {
	   if {$fract == ""} {set fract 1}
	   set list [imgFuncFit $img(profile) $peak $fwhm $fract]
	   set peak [lindex $list 0]
	   set fwhm [lindex $list 1]
	   set img(peak) $peak
	   set img(fwhm) $fwhm
	   echo peak $peak fwhm $fwhm
	} elseif {$yn =="" || $yn == "n"} {
	   break
	} else {
	   }
	}
   return
   }

#####################################################################
proc sech2 {x} {
   return [expr pow(2./(exp($x) + exp(-$x)), 2)]
   }

#####################################################################
#Plot the fit

proc funcFitPlot {} {
   global img
   if {![info exists img(profile)]} {
	echo Need a profile
	return
	}
   if {![info exists img(sky)]} {
	echo Need some sky
	return
	}

   if {![info exists img(peak)] || ![info exists img(fwhm)]} {
	echo Need to fit a function
	return
	}

   global XMIN XMAX YMIN YMAX
   pgSci 1
   pgSym 3
   cplot $img(profile) rad cnts
   set z0 [expr $img(fwhm)*1.414/2.49]
   pgSci 7
   chainEach hndl $img(profile) {
	set rad [exprGet $hndl.rad]
	set th [expr $img(peak)*[sech2 [expr $rad/$z0]] + $img(sky)]
	pgPoint $rad $th 2
	}
   pgSci 1
   return
   }

