#Compute growth curve
#Must have run axes first

proc growth {reg rmax} {
   global growth img
   sky4 $reg
   loop i 1 [expr $rmax+1] {
	circle $reg $i
	set growth($i) [expr -2.5*log10($img(photonet))]
	}
   loop i 1 [expr $rmax+1] {
	set growth($i) [expr $growth($i) - $growth($rmax)]
	}
   return
   }

######################################################
#Compute growth profile from a PROF chain.
proc growth {chain} {
   global growth img
   set rmax [chainSize $chain]
   loop i 0 [chainSize $chain] {
	set hndl [chainGet $chain $i]
	set cum [exprGet $hndl.cum]
	if {$cum == 0} {set cum 1.}
	set growth($i) [expr -2.5*log10($cum)]
	}
   loop i 0 $rmax {
       set growth($i) [expr $growth($i) - $growth([expr $rmax-1])]
	}
   return
   }
