#Top level proc to query postgres database and generate idproc.par
#####################################################################
#Dump everything relevant from postgres

proc idprocQuery {} {
   mconnect sdssdp30 sdssdp
   global runs
   if {[info exists runs]} {unset runs}
   set runs() ""

#First, get start of spooling
   set n [msel idproc "run rerun startMJD" "{column = 6} and \
	{pipeline = spool}"]
   loop i 0 $n {
	set line [mnext]
	set run [lindex $line 0]
	set rerun [lindex $line 1]
	set startMJD [lindex $line 2]
	if {[lsearch $runs() $run] < 0} {
	   lappend runs() $run
	   set runs($run) ""
	   }
	if {[lsearch $runs($run) $rerun] < 0} {
	   lappend runs($run) $rerun
	   }
	set runs($run,$rerun,startMJD) [format %.0f $startMJD]
	set runs($run,$rerun,version) Unknown
	set runs($run,$rerun,endMJD) -9999
	}

#Get photo version - nice to have
   set n [msel idproc "run rerun version" "{column = 6} and \
	{pipeline = frames}"]
   loop i 0 $n {
	set line [mnext]
	set run [lindex $line 0]
	set rerun [lindex $line 1]
	set version [lindex $line 2]
	if {[lsearch $runs() $run] < 0} {
	   echo run $run rerun $rerun has been stuffed but not framed
	   continue
	   }
	if {[lsearch $runs($run) $rerun] < 0} {
	   echo run $run rerun $rerun has been stuffed but not framed
	   }
	set runs($run,$rerun,version) $version
	}

#Last, get end of stuffing
   set n [msel idproc "run rerun endMJD" "{column = 6} and \
	{pipeline = stuff}"]
   loop i 0 $n {
	set line [mnext]
	set run [lindex $line 0]
	set rerun [lindex $line 1]
	set endMJD [lindex $line 2]
	if {[lsearch $runs() $run] < 0} {
	   echo run $run rerun $rerun has been stuffed but not spooled!
	   continue
	   }
	if {[lsearch $runs($run) $rerun] < 0} {
	   echo run $run rerun $rerun has been stuffed but not spooled!
	   }
	set runs($run,$rerun,endMJD) [format %.0f $endMJD]
	}

   set fid [open idproc.par w]
   puts $fid "typedef struct {"
   puts $fid "   int run;"
   puts $fid "   int rerun;"
   puts $fid "   char version<12>;"
   puts $fid "   int startMJD;"
   puts $fid "   int endMJD;"
   puts $fid "   } IDPROC;"
   puts $fid ""
   foreach run [lsort -integer $runs()] {
	foreach rerun $runs($run) {
	   if {$rerun >= 10 && $rerun < 20} continue
	   if {$rerun >= 100} continue
	   puts $fid [list idproc $run $rerun $runs($run,$rerun,version) \
		$runs($run,$rerun,startMJD) $runs($run,$rerun,endMJD)]
	   }
	}
   close $fid
   return
   }

idprocQuery
exit
