########################################################################
#Make a plot of all data in hand, showing good, bad areas & overlaps.

########################################################################
#Make a plot of all data in hand, showing good, bad areas & overlaps.
#Use gifs.

global gifDir
set gifDir gif

proc stripePlotGif {} {
   global curStatus plan chunk
   global gifDir
   global dataRoot

   if {[info exists curStatus]} {
	genericChainDel $curStatus
	unset curStatus
	}

   set file currentStripeStatus.par
   if {![info exists curStatus]} {
	set curStatus [param2Chain $file hdr]
	}

   if {[info exists plan]} {
	genericChainDel $plan
	unset plan
	}

#Read imgPlan file
   set files [lsort [exec find . -name imgPlan*.par]]
   set file [lindex $files end]
   echo Reading $file
   if {$file != ""} {
	set plan [param2Chain $file hdr]
	}

#Read todo file (for SEGUE > 1000 stripes only)
   set files [lsort [exec find . -name todo*.par]]
   set file [lindex $files end]
   echo Reading $file
   if {$file != ""} {
	set todo [param2Chain $file hdr]
	}

#Get target chunks for main survey.
   set files [lsort [exec find . -name odChunkStatus*.par]]
   set file [lindex $files end]
   echo Reading $file
   if {$file != ""} {
	set chunk [param2Chain $file hdr]
	}

#Make a web page
   set fid [open stripeStatus.html w]
   puts $fid "<html>"
   puts $fid "<head>"
   puts $fid "<title>Stripe Status</title>"
   puts $fid "</head>"
   puts $fid ""
   puts $fid "<body bgcolor=white>"
   puts $fid "<h1>Stripe Status on [fmtclock [getclock]]</h1>\n"
   puts $fid "<table align=center>\n"
   puts $fid "<tr><td><font color=blue>Stripe Limits</font></td></tr>\n"
   puts $fid "<tr><td><font color=magenta>Area resolved/used for target \
	   selection</font></td></tr>\n"
   puts $fid "<tr><td><font color=green>Data with good \
	   seeing</font></td></tr>\n"
   puts $fid "<tr><td><font color=red>Data with bad seeing</font></td></tr>\n"
   puts $fid "<tr><td><font color=yellow>Area left to-do</font></td></tr>\n"
   puts $fid "</table><p>\n"

#Min and max of plots
   set amin -90.
   set amax 70.

#Max width of bars in pixels
   set width 800.
   set height 5
   set stripes ""
   loop i 45 0 -1 {lappend stripes $i}
   lappend stripes 76 86

#Segue
   set chain [param2Chain segue.par hdr]
   chainEach hndl $chain {
	set stripe [exprGet $hndl.stripe]
	if {[lsearch $stripes $stripe] < 0} {lappend stripes $stripe}

#Fetch chunks.  At this point I do not have a file of segue chunks, so
#I will read from bestRoot directories.

	set bestRoot $dataRoot/bestRoot
	set files [lsort [glob -nocomplain $bestRoot/stripe$stripe*]]
	foreach file $files {
           set tail [file tail $file]
           if {![regexp {stripe([0-9]+)_mu([0-9]+)_([0-9]+)} \
        	$tail all stripe nchunk version]} continue
           if {$stripe > 100} {
        	set list [stripeLimits $stripe]
        	set node [keylget list node]
        	set incl [keylget list incl]
           } else {
        	set node 95.
        	set incl [inclFromStripeNumber $stripe]
        	}
	   set chunkFile $file/tsChunk-$stripe-$nchunk-$version.par
           if {![file exists $chunkFile]} {
        	echo Weird - no chunkFile $chunkFile
        	continue
        	}
	   set cchain [param2Chain $chunkFile hdr]
	   loop i 0 [chainSize $cchain] {
		set hhndl [chainGet $cchain $i]
		foreach param "run camCol rerun stripeNumber strip startMu \
		   endMu field0 nFields" {
		   set $param [exprGet $hhndl.$param]
		   }
		handleDel $hhndl
		set slongStart [expr $startMu/3600. - 185.]
		set slongEnd [expr $endMu/3600. - 185.]
		set chndl [genericNew CHUNK]
		handleSet $chndl.run $run
		handleSet $chndl.rerun $rerun
		handleSet $chndl.camcol $camCol
		handleSet $chndl.stripe $stripeNumber
		handleSet $chndl.strip $strip
		handleSet $chndl.startField $field0
		handleSet $chndl.endField [expr $field0 + $nFields - 1]
		handleSet $chndl.slongStart $slongStart
		handleSet $chndl.slongEnd $slongEnd
		handleSet $chndl.version $version
		handleSet $chndl.startMu $startMu
		handleSet $chndl.endMu $endMu
		handleSet $chndl.startMuSeg $startMu
		handleSet $chndl.endMuSeg $endMu
		handleSet $chndl.status primary
		chainAdd $chunk $chndl
		}
	   }
	}
   genericChainDel $chain

#Put south equator last because it is so big!
   lappend stripes 82

   foreach stripe $stripes {
	set list [imgStripeLimits $stripe]
	set lmin [keylget list lambdaMin]
	set lmax [keylget list lambdaMax]

#For survey stripes > 45, subtract 180 from limits so they have the same
#range as for low numbers stripes.  This trick does not work well, though,
#for Segue stripes.
	if {$stripe > 45 && $stripe < 100} {
	   set lmin [expr $lmin-180]
	   set lmax [expr $lmax+180]
	   }

#For SEGUE, work with great circle coords exclusively, since that is how
#I track things in the observing plan.
	if {$stripe > 100} {
	   set lmin [expr $lmin + 185.]
	   set lmax [expr $lmax + 185.]
	   if {$lmin >= 360.} {
		set lmin [expr $lmin - 360.]
		}
	   if {$lmax < $lmin} {
		set lmax [expr $lmax + 360.]
		}
	   }
	foreach strip "N S" {
	   set subChain [chainSearch $curStatus "{stripe = $stripe} \
		{strip<0> = $strip}"]
	   if {[chainSize $subChain] == 0} {
		chainDel $subChain
		continue
		}
	   echo $stripe $strip
	   set pfile $gifDir/$stripe-$strip.gif
	   pgBegin $pfile/GIF

#Double window for stripe 82
	   if {$stripe == 82} {
		pgGeomSet 800 1600 0 0
		pgSch .5
	   } else {
		pgGeomSet 800 200 0 0
		pgSch 2
		}
	   pgScr 0 1 1 1
	   pgScr 1 0 0 0
	   pgScr 7 .7 .7 0
	   set y 0
	   pgSci 1
	   pgSlw 1
	   if {$stripe > 100} {
		set amin [expr $lmin - 20.]
		set amax [expr $lmax + 20.]
	   } else {
		set amin -90.
		set amax 70.
		}
	   if {$stripe == 82} {
		pgEnv $amin $amax 130 0 0 0
	   } else {
		pgEnv $amin $amax 15 0 0 0
		}
	   if {$stripe < 100} {
		pgLabel "Survey Longitude" "" "$stripe-$strip"
	   } else {
		pgLabel "GC Longitude" "" "$stripe-$strip"
		}
	   puts $fid "<li>$stripe-$strip<br>"
	   puts $fid "<img src=\"$gifDir/$stripe-$strip.gif\">\n"
	   set start [max $lmin $amin]
	   set end [min $lmax $amax]
	   set len [expr round(($end - $start) \
		*$width/($amax - $amin))]
	   pgSlw 4
	   pgSci 4
	   incr y
	   pgLine "$start $end" "$y $y"
	   pgSci 1
	   pgSlw 1
	   pgText [expr $amin+2] [expr $y-.1] "Limit"

#Plot out chunk segments
	   set chunkChain [chainSearch $chunk "{stripe = $stripe} \
		{strip<0> = $strip}"]
	   if {[chainSize $chunkChain] > 0} {

#Try merging all chunks onto 1 line.
	        incr y
	        pgText [expr $amin+2] [expr $y-.1] "Chunks"
		chainEach hndl $chunkChain {
		   set run [exprGet $hndl.run]
		   set start [exprGet $hndl.slongStart]
		   set end [exprGet $hndl.slongEnd]
		   if {$stripe > 45 && $stripe < 100} {
			set start [expr $start-180.]
			if {$start < -180.} {set start [expr $start+360.]}
			set end [expr $end-180.]
			if {$end < -180.} {set end [expr $end+360.]}
			}
		   if {$stripe > 100} {
			set start [expr $start + 185.]
			set end [expr $end + 185.]
			if {$start < $amin} {
			   set start [expr $start + 360.]
			   }
			if {$start > $amax} {
			   set start [expr $start - 360.]
			   }
			while {$end < $start} {
			   set end [expr $end + 360.]
			   }
			}
		   set start [max $start $amin]
		   set end [min $end $amax]
#		   incr y
		   pgSlw 4
		   pgSci 6
		   pgLine "$start $end" "$y $y"
		   pgSci 1
		   pgSlw 1
#		   pgText [expr $amin+2] [expr $y-.1] "Chunk run $run"
		   }
		}
	   chainDel $chunkChain

	   set runs ""
	   chainEach hndl $subChain {
		set run [exprGet $hndl.run]
		if {[lsearch $runs $run] < 0} {
		   lappend runs $run
		   set n($run) 0
		   }
		foreach var "lambdaStart lambdaEnd status" {
		   set ${var}($run,$n($run)) [exprGet $hndl.$var]
		   }
		if {$stripe > 45 && $stripe < 100} {
		   set lambdaStart($run,$n($run)) [expr \
			$lambdaStart($run,$n($run)) - 180.]
		   if {$lambdaStart($run,$n($run)) < -180.} {
			set lambdaStart($run,$n($run)) [expr \
			   $lambdaStart($run,$n($run)) + 360.]
			}
		   set lambdaEnd($run,$n($run)) [expr \
			$lambdaEnd($run,$n($run)) - 180.]
		   if {$lambdaEnd($run,$n($run)) < -180.} {
			set lambdaEnd($run,$n($run)) [expr \
			   $lambdaEnd($run,$n($run)) + 360.]
			}
		   }
		if {$stripe > 100} {
		   set lambdaStart($run,$n($run)) [expr \
			$lambdaStart($run,$n($run)) + 185.]
		   set lambdaEnd($run,$n($run)) [expr \
			$lambdaEnd($run,$n($run)) + 185.]
		   if {$lambdaStart($run,$n($run)) < $amin} {
			set lambdaStart($run,$n($run)) [expr \
			   $lambdaStart($run,$n($run)) + 360.]
			}
		   if {$lambdaStart($run,$n($run)) > $amax} {
			set lambdaStart($run,$n($run)) [expr \
			   $lambdaStart($run,$n($run)) - 360.]
			}
		   while {$lambdaEnd($run,$n($run)) < \
			$lambdaStart($run,$n($run))} {
			set lambdaEnd($run,$n($run)) [expr \
			   $lambdaEnd($run,$n($run)) + 360.]
			}
		   }
		incr n($run)
		}

	   foreach run $runs {
		set start [max $lambdaStart($run,0) $amin]
		incr y
		pgSlw 4
		loop i 0 $n($run) {
		   set start [max $lambdaStart($run,$i) $amin]
		   set end [min $lambdaEnd($run,$i) $amax]
		   if {$status($run,$i) == "GOOD"} {
			pgSci 3
		   } elseif {$status($run,$i)== "ACCPETABLE"} {
			pgSci 6
		   } elseif {$status($run,$i)== "BAD"} {
			pgSci 2
			}
		   pgLine "$start $end" "$y $y"
		   }
		pgSci 1
		pgSlw 1
		pgText [expr $amin+2] [expr $y-.1] "Run $run"
		}
	   chainDel $subChain

	   if {![info exists plan]} continue

#Plot out plan segments
#Note that segue stripe > 100 are not in imgPlan*.par (although they are
#in the todo file).
	   if {$stripe < 100} {
		set searchChain $plan
	   } else {
		set searchChain $todo
		}
	   set subChain [chainSearch $searchChain "{stripe = $stripe} \
		{strip<0> = $strip}"]
	   if {[chainSize $subChain] > 0} {
		chainEach hndl $subChain {
		   set start [exprGet $hndl.slongStart]
		   set end [exprGet $hndl.slongEnd]
		   if {$stripe > 45 && $stripe < 100} {
			set start [expr $start-180.]
			if {$start < -180.} {set start [expr $start+360.]}
			set end [expr $end-180.]
			if {$end < -180.} {set end [expr $end+360.]}
			}
		   if {$stripe > 100} {
			if {$end < $start} {set end [expr $end+360.]}
			set start [expr $start+185.]
			set end [expr $end+185.]
			if {$start > 360.} {
			   set start [expr $start-360.]
			   set end [expr $end-360.]
			   }
			if {$start < $amin} {
			   set start [expr $start+360.]
			   set end [expr $end+360.]
			   }
			}
		   set start [max $start $amin]
		   set end [min $end $amax]
		   incr y
		   pgSlw 4
		   pgSci 7
		   pgLine "$start $end" "$y $y"
		   pgSlw 1
		   pgSci 1
		   pgText [expr $amin+2] [expr $y-.1]  "TODO"
		   }
		}
	   chainDel $subChain
	   pgEnd
	   puts $fid "<br>"
	   }
	}
   puts $fid "</body>"
   puts $fid "</html>"
   genericChainDel $chunk
   close $fid
   return
   }

########################################################################
#Make one summary plot of data in currentStripeStatus.par
#Make a gif unless Xwindow is open.

proc imgPlotSummary {} {
   global stats
   set chain [param2Chain currentStripeStatus.par hdr]
   set flag 0
   if {[pgQinf STATE] == "CLOSED"} {
	pgBegin imgSummary.gif/VGIF
	pgGeomSet 700 900 0 0
	pgAsk 0
	set flag 1
	}


#Routine to make a plot of the survey area that has been completed.

    set plotLamMin -65
    set plotLamMax 65
    set plotStripeMin -75
    set plotStripeMax 1128

    pgIden
    pgWindow -65 65 -150 1128
    pgBox BCNITS 10.0 2 BC 0.0 0
    pgLabel {lambda} {stripe} {}
    pgSci 1
    pgPtext -30 1250 0 0 "SDSS IMAGING STATUS: [fmtclock [getclock] \
	    {%Y %h %d}]"
    pgSci 5
    set surveyArea [imgArea]
    set baseline [expr 745+7707]
    pgPtext -65 1220 0 0 "Total Area : \
	[format %.0f $surveyArea], Baseline : $baseline"
    pgSci 1
    pgPtext 40 1220 0 0 "Data Quality:"
    pgSci 3
    pgPtext 40 1190 0 0 "GOOD"
    pgSci 7
    pgPtext 60 1190 0 0 "BASELINE"
    pgSci 2
    pgPtext 40 1155 0 0 "BAD"
    if {[info exists stats]} {
 	pgSci 5
	set unique [expr $stats(northunique) + $stats(southunique) + \
	   $stats(equnique)]
	set percent [expr $unique*100./$baseline]
	pgPtext -65 1190 0 0 "Unique Area Imaged: [format %.0f $unique] \
	   ([format %.0f $percent])% "
	pgSci 5
	set pend 0
	set pend [expr $stats(northunreduced) + $stats(southunreduced) + \
	   $stats(equnreduced)]
	set percent [expr $pend*100./$baseline]
	pgPtext -65 1155 0 0 "(Processing Pending :  [format %.0f $pend])"
    }

#List of stripes - don't use astrotools atStripeDef.par anymore.
    set stripes ""
    loop i 1 46 {lappend stripes $i}
    foreach i "72 76 79 82 86 90" {
	lappend stripes $i
	}
    pgScr 17 0.5 0.5 0.5
    pgScr 18 0.3 0.3 0.3
    pgScr 19 0.1 0.1 0.1

    pgSci 17
    set yval 0
    set width 10
    set blw 4
    set slw 1

    foreach stripe $stripes {
        set ylist ""
        set ylist2 ""
	echo stripe is $stripe
	if {$stripe == 72} {set yval -25}
	if {$stripe == 76} {set yval -50}
	if {$stripe == 79} {set yval -75}
        if {$stripe == 82} {set yval -100}
        if {$stripe == 86} {set yval -125}
        if {$stripe == 90} {set yval -150}

#We now have "track" stripes that are not real stripes.  Just move on.
	if {[catch {set list [imgStripeLimits $stripe]}]} continue
        set lambdaMin [keylget list lambdaMin]
        set lambdaMax [keylget list lambdaMax]

        if {$stripe == 76 || $stripe == 82 || $stripe == 86 || \
	   $stripe == 72 || $stripe == 79 || $stripe == 90} {

            set lambdaMin [expr $lambdaMin - 180]
            set lambdaMax [expr $lambdaMax -180]
            if {$lambdaMin < -180 } {
                set lambdaMin [expr $lambdaMin +360]
            }
            if {$lambdaMax < -180 } {
                set lambdaMax [expr $lambdaMax +360]
            }
        }
        
        pgSci 1
        pgRect -65.0 65.0 [expr $yval+1] [expr $yval + $blw-1]
        set yval [expr $yval + $blw]
        pgSci 18
        pgRect $lambdaMin $lambdaMax [expr $yval+1] [expr $yval + $width-1]
        set yval [expr $yval + $width]
        pgSci 1
        pgSch 0.9
        pgPtext -70 [expr $yval - $width/2] 0.0 0.0 $stripe
        pgSch 1.0
        pgSci 17
        pgRect -65.0 65.0 [expr $yval+1] [expr $yval + $slw-1]
        set yval [expr $yval + $slw]
        pgSci 18
        pgRect $lambdaMin $lambdaMax [expr $yval+1] [expr $yval + $width-1]

        set yval [expr $yval + $width]
        pgSci 1

        if {$stripe == 45} {
            pgRect -65.0 65.0 [expr $yval+1] [expr $yval + $blw-1]          
        }

    }

   chainEach hndl $chain {
	set stripe [exprGet $hndl.stripe]
	set strip [exprGet $hndl.strip]
	set lambdaStart [exprGet $hndl.lambdaStart]
	set lambdaEnd [exprGet $hndl.lambdaEnd]
	set status [string tolower [exprGet $hndl.status]]
	if {$status != "bad"} continue
	set len [expr $lambdaEnd-$lambdaStart]
	if {$lambdaEnd < $lambdaStart} {
	   set len [expr $len+360.]
	   }
	if {$lambdaStart > 90.} {
	   set lambdaStart [expr $lambdaStart-180.]
	   }
	if {$lambdaStart < -90.} {
	   set lambdaStart [expr $lambdaStart+180.]
	   }
	scanPlot $stripe $strip $lambdaStart 0 $len $status
	}
   chainEach hndl $chain {
	set stripe [exprGet $hndl.stripe]
	set strip [exprGet $hndl.strip]
	set lambdaStart [exprGet $hndl.lambdaStart]
	set lambdaEnd [exprGet $hndl.lambdaEnd]
	set status [string tolower [exprGet $hndl.status]]
	if {$status != "good"} continue
	set len [expr $lambdaEnd-$lambdaStart]
	if {$lambdaEnd < $lambdaStart} {
	   set len [expr $len+360.]
	   }
	if {$lambdaStart > 90.} {
	   set lambdaStart [expr $lambdaStart-180.]
	   }
	if {$lambdaStart < -90.} {
	   set lambdaStart [expr $lambdaStart+180.]
	   }
	scanPlot $stripe $strip $lambdaStart 0 $len $status
	}
   if {$flag == 1} {echo pgEnd; pgEnd}
   return
}

#####################################################################
proc scanPlot {stripe strip lambdaStart eta lengthOfRun quality} {
    
    if {$stripe == 100} {set stripe 10}
    if {$stripe == 72} {set stripe 0}
    if {$stripe == 76} {set stripe -1}
    if {$stripe == 79} {set stripe -2}
    if {$stripe == 82} {set stripe -3}
    if {$stripe == 86} {set stripe -4}
    if {$stripe == 90} {set stripe -5}
     
    set yval 0
    set width 10
    set blw 4
    set slw 1
    
   if {$quality == "good"} {
	pgSci 3
   } else {
	pgSci 2
	}
    if {$strip == "S"} {
        set yval [expr ($stripe-1)*$width*2 + $stripe*$blw + $stripe*$slw]
        pgRect [expr $lambdaStart] [expr $lambdaStart+$lengthOfRun] [expr $yval] [expr $yval + $width - 3]
    }
    
    if {$strip == "N"} {
        set yval [expr ($stripe-1)*$width*2 + $width + $slw + $stripe*$blw + $stripe*$slw]
        pgRect [expr $lambdaStart] [expr $lambdaStart+$lengthOfRun] [expr $yval] [expr $yval + $width - 2]
    }

    pgSci 1
#    pgEnd
}

###################################################################
#Clean up old files

proc purge {{ftypes ""}} {
   set yn ""
   if {$ftypes == ""} {

#All file types, and now including plan, since I archive those
#separately anyway.
	set ftypes "imgPlan mapReport odChunkStatus tileList tileReport \
	   todo plateList plateReport odPatchStatus princetonQuality \
	   odChunkStatus odPatchStatus plan segueChunk"
	puts stdout "Clearing out all file types - OK? " nonewline
	purge stdout
	set yn [gets stdin]
	if {$yn != "y"} {
	   echo Abort
	   return
	   }
	}
   foreach ftype $ftypes {
	set files [lsort [exec find . -name $ftype-*.par]]
	if {[llength $files] == 0} continue
	loop i 0 [expr [llength $files]-1] {
	   exec rm -f [lindex $files $i]
	   }
	echo Last file [lindex $files end]
	}

#Delete princetonQuality.txt files
   if {$yn == "y"} {
	set files [lsort [exec find . -name princetonQuality*.txt]]
	loop i 0 [llength $files] {
	   exec rm -f [lindex $files $i]
	   }
	}
   return
   }

########################################################################
#Make one summary plot of data in currentStripeStatus.par
#Make a gif unless Xwindow is open.
#Use RA, DEC

proc imgPlotEq {} {
   global stats
   set chain [param2Chain currentStripeStatus.par hdr]
   set flag 0
   if {[pgQinf STATE] == "CLOSED"} {
	pgBegin imgEqSummary.gif/VGIF
	pgGeomSet 900 600 0 0
	pgAsk 0
	set flag 1
	}

#Routine to make a plot of the survey area that has been completed.

    pgEnv 360 0 -12 90 0 0
    pgLabel {RA} {DEC} {SDSS Coverage}
    pgSci 1
   chainEach hndl $chain {
	set stripe [exprGet $hndl.stripe]
	set strip [exprGet $hndl.strip]
	set lambdaStart [exprGet $hndl.lambdaStart]
	set lambdaEnd [exprGet $hndl.lambdaEnd]
	set status [string tolower [exprGet $hndl.status]]
	set len [expr $lambdaEnd-$lambdaStart]
	if {$lambdaEnd < $lambdaStart} {
	   set len [expr $len+360.]
	   }
	eqScanPlot $stripe $strip $lambdaStart $len $status
	}
   if {$flag == 1} {echo pgEnd; pgEnd}
   return
}

#####################################################################
proc eqScanPlot {stripe strip lambdaStart lengthOfRun quality} {
    
   if {$quality == "good"} {
	pgSci 3
   } else {
	pgSci 2
	}


#Work in great circle coords
   if {$stripe < 100} {
	set node 95.
	if {[catch {set list [stripeLimits $stripe]}]} return
	set eta [keylget list eta]
	set incl [expr $eta + 32.5]
   } elseif {$stripe == 100} {
	return
   } else {
	if {[catch {set list [stripeLimits $stripe]}]} return
	set node [keylget list node]
	set incl [keylget list incl]
	}
   set nu 0.
   if {$strip == "S"} {
	   set nu [expr $nu-.625]
	   }
   if {$strip == "N"} {
	   set nu [expr $nu+.625]
	   }
   loop i 0 $lengthOfRun {
	set lambda [expr $i + $lambdaStart]
	set mu [expr $lambda + 185.]
	set list [GCToEq $mu $nu -node $node -inclination $incl]
	set ra [keylget list ra]
	set dec [keylget list dec]
	pgPoint $ra $dec 4
	}
    pgSci 1
   return
}


