proc listMatch {list1 list2} {
   upvar 1 x1list x1list
   upvar 1 y1list y1list
   upvar 1 x2list x2list
   upvar 1 y2list y2list
   set x1list ""
   set y1list ""
   set var1list ""
   linkInit $list1 iter
   for {set i 0} {$i < [listSize $list1]} {incr i} {
	set handle [linkNext iter]
	lappend x1list [handleShow $handle.row]
	lappend y1list [handleShow $handle.col]
	lappend var1list .2
	}
   linkNext iter
   set x2list ""
   set y2list ""
   set var2list ""
   linkInit $list2 iter
   for {set i 0} {$i < [listSize $list2]} {incr i} {
	set handle [linkNext iter]
	lappend x2list [handleShow $handle.row]
	lappend y2list [handleShow $handle.col]
	lappend var2list .2
	}
   linkNext iter
   set coefflist [triMatch $x1list $y1list $var1list $x2list $y2list $var2list]
   echo $coefflist
   listTrans $x1list $y1list $x2list $y2list $coefflist
   return
   }

proc listTrans {xorglist yorglist xlist ylist coefflist} {
   set nelem [llength $xorglist]
   echo "First List"
   for {set i 0} {$i < $nelem} {incr i} {
	set x [lindex $xorglist $i]
	set y [lindex $yorglist $i]
	echo [format "%8.2f%8.2f" $x $y]
	}
   set a [lindex $coefflist 0]
   set b [lindex $coefflist 1]
   set c [lindex $coefflist 2]
   set d [lindex $coefflist 3]
   set e [lindex $coefflist 4]
   set f [lindex $coefflist 5]
   set nelem [llength $xlist]
   echo "Second List"
   echo "   Original      Transformed "
   upvar 2 xtranslist xtranslist
   upvar 2 ytranslist ytranslist
   set xtranslist ""
   set ytranslist ""
   for {set i 0} {$i < $nelem} {incr i} {
	set x [lindex $xlist $i]
	set y [lindex $ylist $i]
	set xtrans [expr ($x)*($a)+($y)*($b)+($c)]
	set ytrans [expr ($x)*($e)+($y)*($d)+($f)]
	echo [format "%8.2f%8.2f   %8.2f%8.2f" $x $y \
		$xtrans $ytrans]
	lappend xtranslist $xtrans
	lappend ytranslist $ytrans
	}
   }
