# print a list out 11 items per line
proc patch_lprint {a} {
   for {} {[llength $a] != 0} {} {
	set outline " "
	for {set i 0} {$i < 11} {incr i} {
	   set temp [format "%s%7.7s" $outline [lindex $a 0 ]]
	   set outline $temp
	   set a [lreplace $a 0 0]
	   if { [llength $a] == 0} then break else {}
	   }
	puts stdout $outline
	}
   }

# create a list of one row of pixels and print
# row is row number; print col1 to col2
proc patch_prow {reg row col1 col2} {
   set list ${row}:
   for {set i $col1} {$i <= $col2} {incr i} {
	lappend list [format %.0f [regPixGet $reg $row $i]]
	}
   patch_lprint $list
   }

# print a bunch of rows

proc patch {reg row col {rwidth 4} {cwidth 4}} {
   set row [floor $row]
   set col [floor $col]
#In updated tclX, floor returns a floating point number; int returns an integer
   if {[info commands int] != ""} then {
	set row [int $row]
	set col [int $col]
	}
   set ncol [exprGet $reg.ncol]
   set nrow [exprGet $reg.nrow]
   set row1 [expr {$row - $rwidth}]

   if {[expr {$cwidth < 0}]} then {set cwidth [expr -$cwidth]} else {}
   if {[expr {$rwidth < 0}]} then {set rwidth [expr -$rwidth]} else {}

   if {[expr {$row1 < 0}]} then {set row1 0} else {}
   set row2 [expr {$row + $rwidth}]
   if {[expr {$row1 > $nrow}]} then {set row2 $nrow} else {}
   set col1 [expr {$col - $cwidth}]
   if {[expr {$col1 < 0}]} then {set col1 0} else {}
   set col2 [expr {$col + $cwidth}]
   if {[expr {$col2 > $ncol}]} then {set col2 $ncol} else {}

   set list "Row/col"
   for {set i $col1} {$i <= $col2} {incr i} {
	lappend list $i
	}
   patch_lprint $list
   for {set i $row1} {$i <= $row2} {incr i} {
	patch_prow $reg $i $col1 $col2
	}
#Now compute statistics.
   set list [imgStats $reg $row1 $row2 $col1 $col2]
   set mean [keylget list mean]
   set stdev [keylget list stdev]
   set min [keylget list min]
   set max [keylget list max]
   echo [format "Mean %8.2f   Stdev %8.2f   Min %8.2f    Max %8.2f" \
	$mean $stdev $min $max]
   }

# left cursor print command
proc pc {{rwidth 4} {cwidth 4}} {
   set coords [getcur]
   if {$coords == ""} return
   set row [int [lindex $coords 0]]
   set col [int [lindex $coords 1]]
   set reg [lindex $coords 2]
   patch $reg $row $col $rwidth $cwidth
   }
