proc regOut {reg} {
   set nrow [handleShow $reg.nrow]
   set ncol [handleShow $reg.ncol]
   spawn a.out "[exprGet $reg.nrow] [exprGet $reg.ncol]" rfid wfid
   set type [string tolower [handleShow $reg.type]]
   regsub "type_" $type "" type
   loop i 0 $nrow {
	binWrite $wfid "((USHORT **)($reg.rows_$type))<$i><0>" [expr $ncol*2]
	}
   flush $wfid
   sleep 1
   while {1} {
	set line [gets $rfid]
   	if {[eof $rfid]} then break
	echo $line
	flush stdout
	}
   close $rfid
   close $wfid
   }

proc spawn {exe arg rpipe wpipe} {
   upvar 1 $rpipe read1
   upvar 1 $wpipe write2
   pipe read1 write1
   pipe read2 write2
   set pid [fork]
   if {$pid == 0} then {
	dup $write1 stdout
	dup $read2 stdin
	close $write1
	close $read2
	execl $exe $arg
	}
   close $write1
   close $read2
   fcntl $write2 NOBUF 1
   fcntl $read1 NOBUF 1
   return
   }
