#Some qa scripts that are extensions of existing code.
#First, compute median and stdev of ap. corrections in 5 filters, 6 columns
#for a run in groups of 10 fields.

proc qaPhotom {run} {
   global qaApcor
   mtGlobals
   set filter(0) u; set filter(1) g; set filter(2) r; set filter(3) i
   set filter(4) z
   if {![info exists qaApcor]} {
	set qaApcor() $run
   } elseif {[lsearch $qaApcor() $run] < 0} {
	lappend qaApcor() $run
	}
   if {![info exists asdir($run)]} {dataDirs $run}
   astromRead $run
echo Special hack for 1350
   foreach camcol "2 3 4 5 6" {
echo camcol $camcol
	set hndl [chainGet $astrom($run,$camcol,r) 0]
	set field0 [exprGet $hndl.field]
	handleDel $hndl

#Astrom goes 1 more field than objc, typically
	set nfields [expr [chainSize $astrom($run,$camcol,r)] -1]
	set qaApcor($run,$camcol) ""
	loop i 0 $nfields 10 {
	   lappend qaApcor($run,$camcol) [expr $i+$field0]
	   }
	foreach ifil "0 1 2 3 4" {
	   loop i 0 $nfields 10 {
		set field1 [expr $i + $field0]
		set fieldn [min [expr $field1+10] [expr $field0 + $nfields]]
echo Fields are $field1 $fieldn
		set list [photomSumCheck $run $camcol $field1 $fieldn \
		   7 $ifil]
		set qaApcor($run,$camcol,$field1,$filter($ifil),median) \
		   [lindex $list 0]
		set qaApcor($run,$camcol,$field1,$filter($ifil),sigma) \
		   [lindex $list 1]

		}
	   }
	}
   return
   }

########################################################################
#Plot results of above
proc qaPhotomPlot {run} {
   global qaApcor
   if {![info exists qaApcor]} return
   set color(u) 5; set color(g) 3; set color(r) 2; set color(i) 6;
	set color(z) 7
   if {[pgQinf STATE] == "CLOSED"} {
	pgBegin; sleep 1; update
	pgGeomSet 1200 1100 10 25
	pgAsk 0
	}
   pgSci 1
   pgEnv 0 800 -.6 .6 0 0
   pgLabel FRAME Residual "Run $run"
   echo Hacked for 1350
   foreach camcol "2 3 4 5 6" {
	set off [expr ($camcol-3.5)*.2]
	foreach filter "u g r i z" {
	   pgSci $color($filter)
	   foreach field $qaApcor($run,$camcol) {
		set p [expr $qaApcor($run,$camcol,$field,$filter,median) \
		   + $off]
		set s $qaApcor($run,$camcol,$field,$filter,sigma)
		set q1 [expr $p-$s]
		set q3 [expr $p+$s]
		pgPoint $field $p 3
		pgLine "$field $field" "$q1 $q3"
		}
	   }
	pgSci 1
	pgLine "0 800" "$off $off"
	}
   return
   }

####################################################################
proc qaWrite {run} {
   global qaApcor
   set file qa-$run.par
   set fid [open $file w]
   echo Hacked for 1350
   foreach camcol "2 3 4 5 6" {
	puts $fid "set qaApcor($run,$camcol) \"$qaApcor($run,$camcol)\""
	foreach filter "u g r i z" {
	   foreach field $qaApcor($run,$camcol) {
		puts $fid "set qaApcor($run,$camcol,$field,$filter,median) \
		   $qaApcor($run,$camcol,$field,$filter,median)"
		puts $fid "set qaApcor($run,$camcol,$field,$filter,sigma) \
		   $qaApcor($run,$camcol,$field,$filter,sigma)"
		}
	   }
	}
   close $fid
   return
   }

