#Wrappers for the rowavg, colavg, colmed routines.

proc rowMed {regIn} {
   if {[handleType $regIn] != "REGION"} {error "$regIn not a REGION"}
   set regOut [regNew [exprGet $regIn.nrow] 1 -type FL32]
   imgRowMed $regIn $regOut
   return $regOut
   }

proc colMed {regIn} {
   if {[handleType $regIn] != "REGION"} {error "$regIn not a REGION"}
   set regOut [regNew 1 [exprGet $regIn.ncol] -type FL32]
   imgColMed $regIn $regOut
   return $regOut
   }

proc rowAvg {regIn} {
   if {[handleType $regIn] != "REGION"} {error "$regIn not a REGION"}
   set regOut [regNew [exprGet $regIn.nrow] 1 -type FL32]
   imgRowAvg $regIn $regOut
   return $regOut
   }

proc colAvg {regIn} {
   if {[handleType $regIn] != "REGION"} {error "$regIn not a REGION"}
   set regOut [regNew 1 [exprGet $regIn.ncol] -type FL32]
   imgColAvg $regIn $regOut
   return $regOut
   }

proc ntile {reg args} {
   set row1 0
   set row2 [exprGet $reg.nrow]
   set col1 0
   set col2 [exprGet $reg.ncol]
   return [eval imgNtile $reg $row1 $row2 $col1 $col2 $args]
   }

proc rowsPlot {reg row1 row2 col1 col2} {
   set nrow [expr $row2-$row1]
   set ncol [expr $col2-$col1]
   set subReg [subRegNew $reg $nrow $ncol $row1 $col1]
   set colVec [colAvg $subReg]
   plotrow $colVec 0 0 $ncol
   regDel $colVec
   regDel $subReg
   return
   }

proc rowsMedPlot {reg row1 row2 col1 col2} {
   set nrow [expr $row2-$row1]
   set ncol [expr $col2-$col1]
   set subReg [subRegNew $reg $nrow $ncol $row1 $col1]
   set colVec [colMed $subReg]
   plotrow $colVec 0 0 $ncol
   regDel $colVec
   regDel $subReg
   return
   }

proc colsPlot {reg row1 row2 col1 col2} {
   set nrow [expr $row2-$row1]
   set ncol [expr $col2-$col1]
   set subReg [subRegNew $reg $nrow $ncol $row1 $col1]
   set rowVec [rowAvg $subReg]
   plotcol $rowVec 0 0 $nrow
   regDel $rowVec
   regDel $subReg
   return
   }

proc colsMedPlot {reg row1 row2 col1 col2} {
   set nrow [expr $row2-$row1]
   set ncol [expr $col2-$col1]
   set subReg [subRegNew $reg $nrow $ncol $row1 $col1]
   set rowVec [rowMed $subReg]
   plotcol $rowVec 0 0 $nrow
   regDel $rowVec
   regDel $subReg
   return
   }
