#Top level proc to query postgres database and generate sdproc.par
#####################################################################
#Dump everything relevant from postgres

proc sdprocQuery {} {
   mconnect sdssdp30 sdssdp
   global plates
   if {[info exists plates]} {unset plates}
   set plates() ""

#Select every plate with plateId > 265
#First do 2d
   set names "plate mjd startMJD endMJD rerun"
   set n [msel spproc $names "{plate > 265} and {pipeline = spec2d}"]
   loop i 0 $n {
	set line [mnext]
	loop i 0 [llength $names] {
	   set name [lindex $names $i]
	   set $name [lindex $line $i]
	   }
	if {$rerun < 4} continue
	if {[lsearch $plates() $plate] < 0} {
	   lappend plates() $plate
	   set plates($plate) ""
	   }
	if {[lsearch $plates($plate) $mjd] < 0} {
	   lappend plates($plate) $mjd
	   set plates($plate,$mjd) ""
	   }
	if {[lsearch $plates($plate,$mjd) $rerun] < 0} {
	   lappend plates($plate,$mjd) $rerun
	   set plates($plate,$mjd,$rerun,startMJD) [int $startMJD]
	   set plates($plate,$mjd,$rerun,endMJD) -9999
	   }
	}

#Lastly do 1d
   set names "plate mjd startMJD endMJD rerun"
   set n [msel spproc $names "{plate > 265} and {pipeline = spec1d}"]
   loop i 0 $n {
	set line [mnext]
	loop i 0 [llength $names] {
	   set name [lindex $names $i]
	   set $name [lindex $line $i]
	   }
	if {$rerun < 4} continue
	if {[lsearch $plates() $plate] < 0} {
	   echo Weird! Plate $plate has spec1d but not spec2d
	   continue
	   }
	if {[lsearch $plates($plate) $mjd] < 0} {
	   echo Weird! Plate $plate, mjd $mjd has spec1d but not spec2d
	   continue
	   }
	if {[lsearch $plates($plate,$mjd) $rerun] < 0} {
	   echo Weird! Plate $plate, mjd $mjd, rerun $rerun has spec1d but \
		not spec2d
	   continue
	   }
	set plates($plate,$mjd,$rerun,endMJD) [int $endMJD]
	}

   echo Creating file sdproc.par
   set fid [open sdproc.par w]
   puts $fid "typedef struct {"
   puts $fid "   int plate;"
   puts $fid "   int mjd;"
   puts $fid "   int rerun;"
   puts $fid "   int startMJD;"
   puts $fid "   int endMJD;"
   puts $fid "   } SDPROC;"
   puts $fid ""
   foreach plate [lsort -integer $plates()] {
	foreach mjd [lsort -integer $plates($plate)] {
	   foreach rerun [lsort -integer $plates($plate,$mjd)] {
		puts $fid [list sdproc $plate $mjd $rerun \
		   $plates($plate,$mjd,$rerun,startMJD) \
		   $plates($plate,$mjd,$rerun,endMJD)]
		}
	   }
	}
   close $fid
   return
   }

sdprocQuery
exit
