#For MOPDB, be sure to source "coord.tcl" to pick up galToEq
#Compute segue coordinates from a given ra, dec

proc eqToSegue {ra dec} {
   set list [eqToGal $ra $dec]
   set l [keylget list gLong]
   set b [keylget list gLat]
   set stripe [expr 1000 + round(2*$l)]

#ra, dec of galactic pole
   set rap 192.85948099
   set decp 27.12825126
#   set list [defineGC $rap $decp $ra $dec]
   set list [defineGC $ra $dec $rap $decp]
   set node [keylget list node]
   set incl [keylget list inc]
   if {$incl > 90.} {
	set incl [expr 180.-$incl]
	set node [expr $node+180.]
	}
   set node [fmod $node+720. 360.]
   set list [eqToGC $ra $dec -node $node -inclination $incl]
   set mu [keylget list mu]
   set nu [keylget list nu]
   set list ""
   keylset list node $node
   keylset list incl $incl
   keylset list stripe $stripe
   keylset list longitude $mu
   return $list
   }

################################################################
#Convert galactic coords to seque system.

proc galToSegue {l b} {
   set list [galToEq $l $b]
   set ra [keylget list ra]
   set dec [keylget list dec]
   set list [eqToSegue $ra $dec]
   return $list
   }

################################################################
#Get patch RA, DEC.  Input is l, multiple b's.

proc seguePatch {l args} {
   set args [join $args]
   set stripe [expr round(1000+2*$l)]

#Name file for stripe because long. can be fractional.
   set file "segPatch-$stripe.par"
   set fid [open $file w]
   puts $fid "gLong $l"
   puts $fid "stripe $stripe"
   puts $fid ""
   puts $fid "typedef struct {"
   puts $fid "   float gLat;"
   puts $fid "   char patch<2>;"
   puts $fid "   float ra;"
   puts $fid "   float dec;"
   puts $fid "   float lambda;"
   puts $fid "   float eta;"
   puts $fid "   float mu;"
   puts $fid "   float nu;"
   puts $fid "   } SEGPATCH"
   foreach b $args {
	set list [galToEq $l $b]
	set ra [keylget list ra]
	set dec [keylget list dec]
	set list [eqToSegue $ra $dec]
	set node [keylget list node]
	set incl [keylget list incl]
	set mu [format %.3f [keylget list longitude]]
	set nu(A) -1.
	set nu(B) -.33
	set nu(C) .33
	set nu(D) 1
	foreach patch {A B C D} {
	   set list [GCToEq $mu $nu($patch) -node $node -inclination $incl]
	   set ra [format %.3f [keylget list ra]]
	   set dec [format %.3f [keylget list dec]]
	   set list [eqToSurvey $ra $dec]
	   set lambda [format %.3f [keylget list lambda]]
	   set eta [format %.3f [keylget list eta]]
	   set nlast 0
	   set line "segpatch $b $patch $ra $dec $lambda $eta $mu \
		$nu($patch)"
	   puts $fid $line
	   }
	}
   close $fid
   return
   }

