proc sky4 {reg} {
   imgGlobals
   set nrow [handleShow $reg.nrow]
   set ncol [handleShow $reg.ncol]
#Set up 4 subregions
   set skylist ""
   set siglist ""
   loop j 0 2 {
	loop i 0 2 {
	   set ir1 [int [expr $nrow/5+($j*$nrow*3)/5]]
	   set ic1 [int [expr $ncol/5+($i*$ncol*3)/5]]
	   set npr [int [expr $nrow/6]]
	   set npc [int [expr $ncol/6]]
	   set ir2 [expr $ir1+$npr]
	   set ic2 [expr $ic1+$npc]
	   set list [imgNtile $reg $ir1 $ir2 $ic1 $ic2 .25 .5 .75]
	   set sky [lindex $list 1]
	   set q1 [lindex $list 0]
	   set q3 [lindex $list 2]
	   set sig [expr ($q3-$q1)/1.4]
	   lappend siglist [format %.2f $sig]
	   lappend skylist [format %.2f $sky]
	   echo [format "   %.2f %.2f" $sky $sig]
	   }
	}
   set skylist [listSort $skylist]
   set siglist [listSort $siglist]
   set sky [expr ([lindex $skylist 1]+[lindex $skylist 2])/2.]
   set sig [lindex $siglist 0]
   set img(sky) $sky
   set img(skynoise) $sig
   return [format "%.2f %.2f" $sky $sig]
   }

proc sky {reg row col npr npc} {
   imgGlobals
   set nrow [exprGet $reg.nrow]
   set ncol [exprGet $reg.ncol]
   set ir1 [max 0 [int [expr $row-($npr/2)]]]
   set ic1 [max 0 [int [expr $col-($npc/2)]]]
   set ir2 [max 0 [int [expr $row+($npr/2)]]]
   set ic2 [max 0 [int [expr $col+($npc/2)]]]
   set list [imgNtile $reg $ir1 $ir2 $ic1 $ic2 .25 .5 .75]
   set sky [format %.2lf [lindex $list 1]]
   set q1 [lindex $list 0]; set q3 [lindex $list 2]
   set sig [format %.2lf [expr ($q3-$q1)/1.36]]
   set img(sky) $sky
   set img(skynoise) $sig
   return "$sky $sig"
   }

proc listSort {list} {
   set n [llength $list]
   if {$n == 0} then return
   if {$n == 1} then {return $list}
   loop i 0 $n {
	set arr($i) [lindex $list $i]
	}
   set flag 1
   while {$flag} {
	set flag 0
	loop i 1 $n {
	   if {$arr($i) <  $arr([expr $i-1])} then {
		set flag 1
		set temp $arr([expr $i-1])
		set arr([expr $i-1]) $arr($i)
		set arr($i) $temp
		}
	   }
	}
   set list ""
   loop i 0 $n {
	lappend list $arr($i)
	}
   return $list
   }
