#Query opdb for info on tiles and plates.  Let's see what all is there.
#This file is now obsolete - use tilePlot and tileStatus in specdb product.

proc tileQuery {} {
    global photoDb_voltages photo_voltages photoDb_runs photo_runs
    global photoDb_tapes photo_tapes photoDb_bias photo_bias 
    global photoDb_ssc photo_ssc photoDb_astrom photo_astrom
    global photoDb_ps photo_ps photoDb_frames photo_frames photoDb_fcalib
    global photo_fcalib photoDb_segments photo_segments photoDb_targets
    global photo_targets photoDb_first photo_first photoDb_rosat photo_rosat
    global photoDb_tiles photo_tiles photo_plates photo_maps


   if {![inSession]} {opdbConnect}
   set tileChunk() ""
   set itr [queryGet arTile $photo_tiles ""]
   echo Creating tile.par
   set fid [open tile.par w]
   puts $fid "typedef struct {"
   puts $fid "   int tileId;"
   puts $fid "   int chunkId;"
   puts $fid "   float raCen;"
   puts $fid "   float decCen;"
   puts $fid "   } TILE;"
   while {[$itr next]} {
	set tileId [$itr -> id]
	set chunkId [$itr -> tileRunId]
	set hndl [$itr -> coord]
	set raCen [format %.3f [$hndl longitude]]
	set decCen [format %.3f [$hndl latitude]]
	handleDel $hndl
	puts $fid "tile $tileId $chunkId $raCen $decCen"
	if {[lsearch $tileChunk() $chunkId] < 0} {
	   lappend tileChunk() $chunkId
	   set tileChunk($chunkId) ""
	   }
	}
#   echo [lsort -integer $tiles]
   close $fid
   opdbDisconnect

   return
   }

########################################################################
#Get parameters for tileChunks.  Note that chunkStatus.tcl actually
#gets targeting chunks out of the database, and does not link them
#together to get tileChunks.  Here, I read the list of tiles
#and construct an ad-hoc tileChunk boundary.  I could do this with the
#chunkStatus but I would like to get the chunk number as well.  Well,
#I'd really like to merge the methods ...

proc tileChunkPlot {} {

#Collate information for tileChunk boundaries.
   set tileChunk() ""
   set tile() ""

   set chain [param2Chain tile.par hdr]
   chainEach hndl $chain {
	foreach var "tileId chunkId raCen decCen" {
	   set $var [exprGet $hndl.$var]
	   }
	if {[lsearch $tileChunk() $chunkId] < 0} {
	   lappend tileChunk() $chunkId
	   set tileChunk($chunkId) ""
	   }
	lappend tileChunk($chunkId) $tileId
	lappend tile() $tileId
	set tile($tileId,raCen) $raCen
	set tile($tileId,decCen) $decCen
	set tile($tileId,chunkId) $chunkId
	set list [eqToSurvey $raCen $decCen]
	set lambda [keylget list lambda]
	set eta [keylget list eta]

#Compute stripe.
	set stripe [expr round(($eta+32.5)/2.5 + 10)]
	if {$lambda > 90 || $lambda < -90} {
	   set stripe [expr $stripe+72]
	   set lambda [expr $lambda+180.]
	   if {$lambda > 180.} {
		set lambda [expr $lambda-360.]
		}
	   }
	set tile($tileId,stripe) $stripe
	set tile($tileId,lambda) $lambda
	}

   set flag 0
   if {[pgQinf STATE] == "CLOSED"} {
	pgBegin tileChunkSummary.gif/VGIF
	pgGeomSet 700 900 0 0
	pgAsk 0
	set flag 1
   } else {
	pgPage
	}


    set plotLamMin -65
    set plotLamMax 65
    set plotStripeMin -75
    set plotStripeMax 1128

    pgIden
    pgWindow -65 65 -75 1128
    pgBox BCNITS 10.0 2 BC 0.0 0
    pgLabel {lambda} {stripe} {}
    pgSci 1
    pgPtext -30 1250 0 0 "TILED CHUNK STATUS: [fmtclock [getclock] \
	    {%Y %h %d}]"

    set astrotoolsDir [envscan \$ASTROTOOLS_DIR]
    set chn [param2Chain $astrotoolsDir/etc/atStripeDef.par hhh]

    set cursor [chainCursorNew $chn]

    pgScr 17 0.5 0.5 0.5
    pgScr 18 0.3 0.3 0.3
    pgScr 19 0.1 0.1 0.1

    pgSci 17
    set yval 0
    set width 10
    set blw 4
    set slw 1

    chainEach scan $chn {
        set ylist ""
        set ylist2 ""
        set stripe [exprGet $scan.stripeNumber]
	echo stripe is $stripe
        if {$stripe == 76} {set yval -25}
        if {$stripe == 82} {set yval -50}
        if {$stripe == 86} {set yval -75}
        set lambdaMin [exprGet $scan.lambdaMin]
        set lambdaMax [exprGet $scan.lambdaMax]

        if {$stripe == 76 || $stripe == 82 || $stripe == 86 } {

            set lambdaMin [expr $lambdaMin - 180]
            set lambdaMax [expr $lambdaMax -180]
            if {$lambdaMin < -180 } {
                set lambdaMin [expr $lambdaMin +360]
            }
            if {$lambdaMax < -180 } {
                set lambdaMax [expr $lambdaMax +360]
            }
        }
        
        pgSci 1
        pgRect -65.0 65.0 [expr $yval+1] [expr $yval + $blw-1]
        set yval [expr $yval + $blw]
        pgSci 18
        pgRect $lambdaMin $lambdaMax [expr $yval+1] [expr $yval + $width-1]
        set yval [expr $yval + $width]
        pgSci 1
        pgSch 0.9
        pgPtext -70 [expr $yval - $width/2] 0.0 0.0 $stripe
        pgSch 1.0
        pgSci 17
        pgRect -65.0 65.0 [expr $yval+1] [expr $yval + $slw-1]
        set yval [expr $yval + $slw]
        pgSci 18
        pgRect $lambdaMin $lambdaMax [expr $yval+1] [expr $yval + $width-1]
        set yval [expr $yval + $width]
        pgSci 1

        if {$stripe == 45} {
            pgRect -65.0 65.0 [expr $yval+1] [expr $yval + $blw-1]          
        }

        handleDel $scan
        set scan [chainWalk $chn $cursor]
    }

#Get tile chunk boundaries
#Create an output file to use later
   set fid [open tileChunk.par w]
   puts $fid "#Created on [fmtclock [getclock]]"
   puts $fid "typedef struct {"
   puts $fid "   int chunkId;"
   puts $fid "   int stripe;"
   puts $fid "   float lmin;"
   puts $fid "   float len;"
   puts $fid "   } TILECHUNK;"
   puts $fid ""
   foreach chunkId [lsort -integer $tileChunk()] {
	set stripes ""
	foreach tileId $tileChunk($chunkId) {
	   set stripe $tile($tileId,stripe)
	   if {[lsearch $stripes $stripe] < 0} {
		lappend stripes $stripe
		set limits($stripe) ""
		}
	   lappend limits($stripe) $tile($tileId,lambda)
	   }
	foreach stripe [lsort -integer $stripes] {

#Make min, max happy
	   if {[llength $limits($stripe)] == 1} {
		lappend limits($stripe) $limits($stripe)
		}
	   set lmin [expr round([eval min $limits($stripe)]-1.5)]
	   set lmax [expr round([eval max $limits($stripe)]+1.5)]
	   echo chunkId $chunkId stripe $stripe limits $lmin $lmax
	   set len [expr $lmax-$lmin]
	   tileChunkScanPlot $stripe $lmin 0 $len $chunkId
	   puts $fid "tilechunk $chunkId $stripe $lmin $len"
	   }
	}
   close $fid
   if {$flag == 1} {echo pgEnd; pgEnd}
   return
   }

#####################################################################
proc tileChunkScanPlot {stripe lambdaStart eta lengthOfRun chunkId} {
    
    if {$stripe == 100} {set stripe 10}
    if {$stripe == 76} {set stripe 0}
    if {$stripe == 82} {set stripe -1}
    if {$stripe == 86} {set stripe -2}
if {$chunkId < 4} return
if {$chunkId == 22} return     
    set yval 0
    set width 10
    set blw 4
    set slw 1
    
   pgSci 6
   set yval [expr ($stripe-1)*$width*2 + $stripe*$blw \
                + $stripe*$slw]
   pgSfs 4
   pgRect [expr $lambdaStart] [expr $lambdaStart+$lengthOfRun] \
                [expr $yval] [expr $yval + 2.*$width - 3]

   pgSfs 1
   pgSci 1
   pgSch .6
   pgPtext [expr $lambdaStart+$lengthOfRun/2.] [expr $yval+2] 0 0 $chunkId
    pgSci 1
}

######################################################################
proc plateQuery {} {
    global photoDb_voltages photo_voltages photoDb_runs photo_runs
    global photoDb_tapes photo_tapes photoDb_bias photo_bias 
    global photoDb_ssc photo_ssc photoDb_astrom photo_astrom
    global photoDb_ps photo_ps photoDb_frames photo_frames photoDb_fcalib
    global photo_fcalib photoDb_segments photo_segments photoDb_targets
    global photo_targets photoDb_first photo_first photoDb_rosat photo_rosat
    global photoDb_tiles photo_tiles photo_plates photo_maps

   if {![inSession]} {opdbConnect}
   set itr [queryGet arPlate $photo_plates ""]
   echo Creating plate.par
   set fid [open plate.par w]
   puts $fid "typedef struct {"
   puts $fid "   int plateId;"
   puts $fid "   int tileId;"
   puts $fid "   } PLATE;"
   while {[$itr next]} {
	set plateId [$itr -> id]
	set tileId [$itr -> tile]
	set hndl [$itr -> tile]
	set tileId [$hndl -> id]
	objDel $hndl
	puts $fid "plate $plateId $tileId"
	}
   close $fid
   opdbDisconnect
   handleDel $itr
   return
   }

#########################################################################
proc tileInfo {tile} {
    global photoDb_voltages photo_voltages photoDb_runs photo_runs
    global photoDb_tapes photo_tapes photoDb_bias photo_bias 
    global photoDb_ssc photo_ssc photoDb_astrom photo_astrom
    global photoDb_ps photo_ps photoDb_frames photo_frames photoDb_fcalib
    global photo_fcalib photoDb_segments photo_segments photoDb_targets
    global photo_targets photoDb_first photo_first photoDb_rosat photo_rosat
    global photoDb_tiles photo_tiles photo_plates photo_maps

   if {![inSession]} {opdbConnect}
   set itr [queryGet arTile $photo_tiles "id_ = $tile"]
   if {![$itr next]} {
	echo Tile $tile not found
	opdbDisconnect
	handleDel $itr
	return
	}

#Get coordinates
   set coord [$itr -> coord]
   set ra [$coord longitude]
   set dec [$coord latitude]
   handleDel $coord

#Get count of light traps
   set traps [$itr -> lightTraps]
   set ntrap [$traps size]
   handleDel $traps

#Get quality
   set nquality [$itr -> quality]
   set quality [enumIntToString arDataQuality $nquality]

#Get count of targets (this includes holes and all candidate guide stars)
   set targitr [objNew -transient ooItr(arTiledTarget)]
   $itr -> tiledTargets $targitr
   set ntarg 0
   while {[$targitr next]} {
	incr ntarg
	}
   handleDel $targitr

#Get list of plates
   set plateitr [objNew -transient ooItr(arPlate)]
   set plates ""
   $itr -> plates $plateitr
   while {[$plateitr next]} {
	lappend plates [$plateitr -> id]
	}
   handleDel $plateitr

#Get tileRunId
   set tileRunId [$itr -> tileRunId]
   while {[$itr next]} {}
   handleDel $itr

   echo Tile $tile, Chunk$tileRunId, ra = [format %.3f $ra], \
	dec = [format %.3f $dec]
   echo Plates $plates, ntarget = $ntarg, quality = $quality
   opdbDisconnect
   return
   }

#########################################################################
proc plateInfo {plate} {
    global photoDb_voltages photo_voltages photoDb_runs photo_runs
    global photoDb_tapes photo_tapes photoDb_bias photo_bias 
    global photoDb_ssc photo_ssc photoDb_astrom photo_astrom
    global photoDb_ps photo_ps photoDb_frames photo_frames photoDb_fcalib
    global photo_fcalib photoDb_segments photo_segments photoDb_targets
    global photo_targets photoDb_first photo_first photoDb_rosat photo_rosat
    global photoDb_tiles photo_tiles photo_plates photo_maps

   if {![inSession]} {opdbConnect}
   set itr [queryGet arPlate $photo_plates "id_ = $plate"]
   if {![$itr next]} {
	echo Plate $plate not found
	opdbDisconnect
	handleDel $itr
	return
	}

#Get info
   set temp [$itr -> temp]
   set haMin [$itr -> haMin]
   set haMax [$itr -> haMax]
   set mjdDesign [$itr -> mjdDesign]

#Get holes
   set holeitr [objNew -transient ooItr(arHole)]
   $itr -> holes $holeitr
   set nhole 0
   while {[$holeitr next]} {
	incr nhole
	}
   handleDel $holeitr

#Get list of plugged plates
   set plateitr [objNew -transient ooItr(arPluggedPlate)]
   set pluggings ""
   if {[$itr -> pluggedPlates $plateitr]} {
	while {[$plateitr next]} {
	   lappend pluggings [$plateitr -> id]
	   }
	}
   handleDel $plateitr

   echo Plate $plate, temp $temp, haMin $haMin, haMax $haMax, mjd $mjdDesign
   echo PluggedPlates $pluggings, nhole= $nhole
   opdbDisconnect
   return
   }

#######################################################################
