/* 
** -- centroid structure definition
**
*/

#if !defined(CENTROID_H)
#define CENTROID_H
#include "dervish.h"

#define CENTROID_FOUND 1
#define CENTROID_NOT_FOUND 0

#define CCD_ALGORITHM 1

/*
 * Type definition for CENTROID_uc
 */

typedef struct centroid {
   TYPE type;
   struct centroid_lc *next, *prev;
   double xc_ax;      /* x_centroid */
   double yc_ax;      /* y_centroid */
   double xp_ax;      /* x_peak */
   double yp_ax;      /* y_peak */
   double angmaj_ax;  /* last computed major-axis position angle */
   double angmin_ax;  /* last computed minor-axis position angle */
   double ang_ax;     /* actual  position angle */
   double sigmaj_ax;  /* 1 sigma for angmaj_ax */
   double sigmin_ax;  /* 1 sigma for angmin_ax */
   double ecc_ax;     /* */
   double threshold;  /*n above which threshold is computed */
   double box_x;      /* width of box : x */
   double box_y;      /* width of box : y */
   int   algorithm;   /* centroid algorithm */
   int   flag; /* CENTROID_FOUND || CENTROID_NOT_FOUND */
} CENTROID;           /* pragma SCHEMA */


CENTROID *epCentroidNew(void);
RET_CODE epCentroidDel(CENTROID *centroid);

#endif
