/* 
** -- photo structure definition
**
*/

#if !defined(PHOTO_H)
#define PHOTO_H
#include "dervish.h"

#define CIRCLE 0
#define ELLIPSE 1
#define PHOTO_ALGORITHM 1

/*
 * Type definition for PHOTO_uc
 */

typedef struct photo {
   TYPE type;
   struct photo_lc *next, *prev;
   double a;                 /* ellipse axes */
   double b;                 /* ""      """  */
   double net_counts;        /* sky-subtracted counts */
   double total_counts;      /* total counts  */
   double area;              /* last computed major-axis position angle */
   int   flag;               /* 0 CIRCLE || 1 ELLIPSE */
   int   algorithm;          /* photo algorithm */
} PHOTO;           /* pragma SCHEMA */


PHOTO *epPhotoNew(void);
RET_CODE epPhotoDel(PHOTO *photo);

#endif
