/**
**  -- sky structure definition
**
*/

#if !defined(SKYFIND_H)
#define SKYFIND_H
#include "dervish.h"

#define SKY_FOUND 1
#define SKY_NOT_FOUND 0

#define CCD_ALGORITHM 1

/*
 * Type definition for SKYFIND_uc
 */

typedef struct skyfind {
   TYPE type;
   struct skyfind_lc *next, *prev;
   double sky_value;    /* sky value */
   double sky_noise;    /* sky noise */
   int    algorithm;    /* sky finding algorithm */
   int    flag;         /* SKY_FOUND || SKY_NOT_FOUND */
}  SKYFIND;       /* pragma SCHEMA */

SKYFIND *epSkyFindNew(void);
RET_CODE epSkyFindDel(SKYFIND *skyfind);

#endif;

