/*
** -- contour structure definition
**
*/

#if !defined(CONTOUR_H)
#define CONTOUR_H
#include "dervish.h"

/*
 * type definition for CONTOUR_uc
 */


#define N_MAX_CONTOURS 32
#define N_MAX_POINTS_PER_CONTOUR 1024

typedef struct contour {
    TYPE type;
    struct contour_lc *next, *prev;
    int isNewLevel;
    int num_pts;
    double x[N_MAX_POINTS_PER_CONTOUR];
    double y[N_MAX_POINTS_PER_CONTOUR];
    double z[N_MAX_POINTS_PER_CONTOUR];
    double label;
} CONTOUR;		/* pragma SCHEMA */

CONTOUR *idContourNew(void);
RET_CODE idContourDel(CONTOUR *contour);

#endif


