/* 
** -- profile structure definition
**
*/

#if !defined(PROFILE_H)
#define PROFILE_H
#include "img_msg_c.h"

#define PROFILE_FOUND 1
#define PROFILE_NOT_FOUND 0

#define CCD_ALGORITHM 1

/*
 * Type definition for PROFILE
 */
typedef struct profile {
   double radius;  /* radius */
   double xc;      /* x ellipse center */
   double yc;      /* y ellipse center */
   double ang;     /* actual  position angle */
   double ecc;     /* eccentricity*/
   double intensity;
   double a0;      /* fourier coeff. */
   double b0;      /* fourier coeff. */
   double a1;      /* fourier coeff. */
   double b1;      /* fourier coeff. */
   double a2;      /* fourier coeff. */
   double b2;      /* fourier coeff. */
   double a4;      /* fourier coeff. */
   double b4;      /* fourier coeff. */
   double deriv;      /*  */
   int   algorithm;   /* profile algorithm */
   int   flag; /* PROFILE_OK || PROFILE_NOT_FOUND */
} PROFILE;           /* pragma SCHEMA */


PROFILE *imgProfileNew(void);
IMG_CODE imgProfileDel(PROFILE *profile);

#endif
