/* Determine the number of free bytes on a file system */
/* Return as the number of Mbytes */


#ifdef __osf__
#include <sys/mount.h>
#else
#include <sys/types.h>
#include <sys/statfs.h>
#endif

#include <stdio.h>
#include <math.h>

int main(int argc, char **argv) {
   struct statfs statbuf;
   float scale;
   int mbytes;
   if (argc != 2) {
	fprintf (stderr, "Error: Usage \"statfs <disk>\"\n");
	return -1;
	}

   if (statfs(argv[1], &statbuf, sizeof (statbuf), 0) != 0) {
	fprintf (stderr, "Error, function failed.\n");
	return -1;
	}
#ifdef __osf__
   scale = statbuf.f_fsize/pow(2.,20.);
#else
   scale = statbuf.f_bsize/pow(2.,20.);
#endif
   mbytes = statbuf.f_bfree * scale;
   printf ("%d\n", mbytes);
   return 0;
   }
