#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <malloc.h>
#include "gif.h"

/* Process data from an image via piping. Input must be unsigned char */
/* Pass dimension information by argc mechanism; bytes come by stdin */
/* Make a gif! */

int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   int nred, ngreen, nblue;	/* Number of levels for red, green, blue */
   unsigned char *buf;

   int i;

   if (argc != 8) {
	fprintf (stderr, "Usage: regGif <nrow> <ncol> <nbyte> <nred> \
<ngreen> <nblue> <outfile>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);
   nred = atoi(argv[4]);
   ngreen = atoi(argv[5]);
   nblue = atoi(argv[6]);

/* fprintf (stderr, "Dimensions %d %d %d\n", nrow, ncol, nbyte); */

   if (nrow*ncol*nbyte == 0) exit(0);

   buf = (unsigned char *)malloc(nrow*ncol*nbyte);

/* Read full pixels */
   for (i=0; i<nrow; i++) {
	fread (&buf[i*ncol], ncol, nbyte, stdin);
	}

/* Call gif routine */
   gif (buf, ncol, nrow, argv[7], nred, ngreen, nblue);

/* Free up malloced storage */
   free(buf);
   fclose(stdout);
   exit(0);
   return 0;
   }


