/* imgFbs.c --
*  Mar 1993 Steve Kent
*  Very simple find bright object routine.  Use imgRegFindObj for more
*  complete routine.
*/
#include <math.h>
#include "dervish.h"
#include "shGeneric.h"
#include "imgStar.h"
#include "img_msg_c.h"
#include "imgProto.h"

/************************** imgfbs - the action routine **********************/

IMG_CODE imgFbs (REGION *reg, int pixthresh, int pixmax, CHAIN *starlist) {

   STAR *star;
   int what;
   int i,j;
   int id=0;
   int nr = reg->nrow;
   int nc = reg->ncol;

/* Pointer to function to return integer pixel value */
   int (*intpix)(REGION *, int, int) = regPixIntFunc (reg);
/* Pointer to function to return double pixel value */
   double (*dblpix)(REGION *, int, int) = regPixDblFunc (reg);
   AXES axes;
   double dblthresh = pixthresh;

   for (i=1; i<nr-1; i++) {
      for (j=1; j<nc-1; j++) {
	if (dblpix (reg,i,j) > dblthresh && dblpix(reg,i,j) < pixmax) {
		if ((dblpix (reg,i,j) > dblpix (reg,i-1,j-1))
			&& (dblpix (reg,i,j) > dblpix (reg,i,j-1))
			&& (dblpix (reg,i,j) > dblpix (reg,i+1,j-1))
			&& (dblpix (reg,i,j) > dblpix (reg,i-1,j))
			&& (dblpix (reg,i,j) > dblpix (reg,i+1,j))
			&& (dblpix (reg,i,j) > dblpix (reg,i-1,j+1))
			&& (dblpix (reg,i,j) > dblpix (reg,i,j+1))
			&& (dblpix (reg,i,j) > dblpix (reg,i+1,j+1))) {
		   star = (STAR *)shGenericNew("STAR");
		   if (star == NULL) return (IMG_GENERIC_ERROR);
		   id++;
		   star->id = id;
		   star->row = i+0.5;
		   star->col = j+0.5;
		   star->cnts = dblpix(reg, i, j);
		   what = shChainElementAddByPos (starlist, star, "STAR",
			TAIL, AFTER);
		   /*
		   if (imgAxes (reg, i, j, 5, 5, &axes) == IMG_SUCCESS) {
			star->row = axes.row;
			star->col = axes.col;
			star->cnts = axes.cnts;
			star->fwhm = (axes.sigmaj + axes.sigmin)*2.35/2.;
			star->eps = axes.eps;
			star->ang = axes.pos_maj;
			}
			*/
		   }
		}
        }
   }

   return IMG_SUCCESS;
}


