/* encode a png file. */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "png.h"
#include "gd.h"

/*************************************************************************/
#define min(x,y) (x)<(y)? (x) : (y)

/****************************** png *************************************/

void png (unsigned char *img, int nwidth, int nheight, char *outfile,
   int nred, int ngreen, int nblue) {
	int red[256], green[256], blue[256];
	int i, j, k, index;

	int depth;
	int icode;
	int ncolor;
	int ndata;
	int outsize;
	FILE *file;
	int ntot=nwidth*nheight;
	gdImagePtr im;

/* Number of levels is product of red, green blue.  depth is next power of
 * 2 bigger. */
	int nlevel = nred * ngreen * nblue;

printf ("nblue = %d\n", nblue);

/* write out the color table as a linear table */

	for (i=0; i<255; i++) {
	   red[i]=255;
	   green[i]=255;
	   blue[i]=255;
	   }

	ncolor=0;
	for (i=0; i<nred; i++) {
	   for (j=0; j<ngreen; j++) {
		for (k=0; k<nblue; k++) {
		   index = i + nred*j + nred*ngreen*k;
		   if (index >= nred*ngreen*nblue) continue;
		   red[index]=255*i/(nred-1);
		   green[index]=255*j/(ngreen-1);
		   blue[index]=255*k/(nblue-1);
		   ncolor++;
		   }
		}
	  }

	im = gdImageCreate (nwidth, nheight);

	for (i=0; i<ncolor; i++) {
	   gdImageColorAllocate(im, red[i], green[i], blue[i]);
	   }

	for (j=0; j<nheight; j++) {
	   for (i=0; i<nwidth; i++) {
		gdImageSetPixel(im, i, j, (int)img[j*nwidth+i]);
		}
	   }
	file = fopen(outfile, "w");
	gdImagePng(im, file);
/*	fflush(file); */
	fclose(file);
	gdImageDestroy(im);
	}
