#define NDMAX 10
#include <math.h>
#include <stdio.h>
#include "imgProto.h"

/**************************************************************************
*                                                                         *
*  inverts a symmetric routine                                            *
*                                                                         *
**************************************************************************/

/* Return 1 for success, 0 for failure */

static int dyminv(double *a,
	double *b,
	int dimension,
	double *pvrow,
	double *pvcol,
	int *use)
{

register int i, j, h, k=0, l, m, n;
double dmax, diag;
double pvrwb=0.0, pivot=0.0;

  for (i=0; i<dimension; i++)
         *(use+i) = 0;
  
         

  for (n=0; n<dimension; n++)
       {
        dmax = 0.0;
        j=0;

        for (i=0; i<dimension; i++, j +=(i+1))
             {
              diag = fabs(*(a+j));    
              if((diag - dmax) <= 0.0) continue;
              if(*(use + i) >0) continue;

                 dmax = diag;
                 k = i;
                 pivot = *(a + j);

             }    
         

          if (dmax <= 0.0) {
                         /*   failure_exit(n,dimension); */
                            return 0;
                           }
          
             *(use+k) =1;
              l  = (k*(k+1))/2;


               for (i=0; i<dimension; i++)
                 {
                  if (i-k < 0)
                          {
                            *(pvrow + i )= *(a+l);
                            *(pvcol + i )= *(a+l)/pivot;
                            *(a + l)    = 0.0;
                              l +=1;

                           if( *(use +i) ==0) continue;
                           *(pvcol +i ) *=-1.0;
                           continue;
                           } 
                   if (i-k == 0)
                           {
                            *(pvrow + i) = 1.0;
                            *(pvcol + i) = -1.0/pivot;
                            *(a + l) = 0.0;
                            pvrwb = *(b+i);
                            l +=(i+1);
                            *(b+i) = 0.0;
                            continue;
                           } 
                           *(pvrow +i) = *(a + l);
                           *(pvcol +i) = *(a + l)/pivot;
                           *(a+l) = 0.0;
                           if( *(use +i) > 0) *(pvrow +i) *=-1;
                            l +=(i+1);
                   }

                 m = 0;

                 for (i=1; i<dimension+1; i++)
                     {
                      *(b+i-1)  -= pvrwb*(*(pvcol+i-1));

                       for (h=1; h<i+1; h++)
                           {
                             *(a+m) -= (*(pvcol+i-1)) *(*(pvrow+h-1));

                              m+=1;
                           }
                     }
             }

return 1;
}
/***************************************************************************/
/************************************ polyfit ******************************/
/***************************************************************************/

int polyfit (double *x, double *y, int n, int ndim, double *rhs) {

/* Generic fit of a polynomial */
/* y=a+bx+c*x**2... */
   int i, j, k, l;
   double cmat[NDMAX*(NDMAX+1)/2], prt[NDMAX];
   double duma[NDMAX], dumb[NDMAX];
   int dumc[NDMAX];

   l=0;
   for (i=0; i<ndim; i++) {
	rhs[i] = 0;
	for (j=0; j<=i; j++) {
	   cmat[l]=0;
	   l++;
	   }
	}
   for (i=0; i<n; i++) {
	l=0;
	for (j=0; j<ndim; j++) {
	   prt[j] = pow(x[i],j);
	   rhs[j] = rhs[j] + prt[j]*y[i];
	   for (k=0; k<=j; k++) {
		cmat[l] = cmat[l] + prt[j] * prt[k];
		l++;
		}
	   }
	}
   if (dyminv (cmat,rhs,ndim,duma,dumb,dumc) == 0) return 0;
   return 1;
   }

/***************************************************************************/
int polycomp (double *x, double *y, int n, int ndim, double *rhs,
	double *res) {

   int i, j;
   double th;

/* compute residuals */
   for (i=0; i<n; i++) {
	th=0.;
	for (j=0; j<ndim; j++) {
	   th = th + rhs[j]*pow(x[i], j);
	   }
	res[i] = y[i] - th;
	}
   return 1;
   }

/***************************************************************************/
int polyrms (double *res, int n, double *rms) {

   int i;

/* compute residuals */
   *rms=0.;
   for (i=0; i<n; i++) {
	*rms = *rms + pow(res[i], 2);
	}
   *rms=sqrt(*rms/n);
   return 1;
   }

/***************************************************************************/
int polyeval (double *val, double x, double *coeff, int ndim) {

   int j;

/* Evaluate */
/* compute residuals */
   *val = 0.;
   for (j=0; j<ndim; j++) {
	*val = *val + coeff[j]*pow(x, j);
	}
   return 1;
   }
