#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* Process data from an image via piping. Input can be any type */
/* Decimate data */


int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   unsigned char *buf;

   int i, j, k;
   int decimate, ncolout;

   if (argc != 5) {
	fprintf (stderr, "Usage: regDecimate <nrow> <ncol> <nbyte> <decimate>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);
   decimate = atoi(argv[4]);
   if (decimate <= 0) {
	fprintf (stderr, "Decimate must be >= 1\n");
	exit(1);
	}
   ncolout = ncol/decimate;

   if (nrow*ncol*nbyte == 0) exit(0);
   if (ncolout == 0) exit(0);

   buf = (unsigned char *)malloc(ncolout*nbyte);

   for (i=0; i<nrow/decimate; i++) {
	fread (buf, ncol, nbyte, stdin);
 	for (j=0; j<ncolout; j++) {
	   for (k=0; k<nbyte; k++) {
		buf[nbyte*j + k] = buf[nbyte*(int)((j+.5)*decimate) + k];
		}
	   }
	fwrite (buf, ncolout, nbyte, stdout);
	fflush (stdout);
	}

/* Free up malloced storage */
   free(buf);
   fclose(stdout);
   exit(0);
   }
