#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/* Apply a gamma correction to RGB images.  I assume I read 3 lines of
 * ushorts, R - G - B
 */

int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   unsigned short *rbuf, *gbuf, *bbuf;

   int i, j;
   double temp;
   double gamma0, gamma1, sigr, sigg, sigb;

   if (argc != 8) {
	fprintf (stderr, "Usage: regGamma <nrow> <ncol> <nbyte> <gamma>"
"<sig-r> <sig-g> <sig-b>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);
   gamma0 = atof(argv[4]);
   sigr = atof(argv[5]);
   sigg = atof(argv[6]);
   sigb = atof(argv[7]);
fprintf (stderr, "gamma0 = %f\n", gamma0);

   if (nrow*ncol*nbyte == 0) exit(0);


   rbuf = (unsigned short *)malloc(ncol*sizeof(unsigned short));
   gbuf = (unsigned short *)malloc(ncol*sizeof(unsigned short));
   bbuf = (unsigned short *)malloc(ncol*sizeof(unsigned short));

   for (i=0; i<nrow; i++) {
	fread (rbuf, ncol, nbyte, stdin);
	fread (gbuf, ncol, nbyte, stdin);
	fread (bbuf, ncol, nbyte, stdin);
	for (j=0; j<ncol; j++) {
/* gamma is adjusted based on the s/n ratio */
	  if (gbuf[j] > 0) {
	    gamma1 = (gamma0-1.) *
	      sqrt(bbuf[j]*gbuf[j]/((bbuf[j]+sigb)*(gbuf[j]+sigg)));
	    temp = ((double)bbuf[j])*pow(((double)bbuf[j])/gbuf[j], gamma1);
	    if (temp > 65535) {
	      bbuf[j] = 65535;
	    } else {
	      bbuf[j] = temp;
	    }
	    gamma1 = (gamma0-1.) *
	      sqrt(rbuf[j]*gbuf[j]/((rbuf[j]+sigr)*(gbuf[j]+sigg)));
	    temp = ((double)rbuf[j])*pow(((double)rbuf[j])/gbuf[j], gamma1);
	    if (temp > 65535) {
	      rbuf[j] = 65535;
	    } else {
	      rbuf[j] = temp;
	    }
	  }
	}
	fwrite (rbuf, ncol, nbyte, stdout);
	fwrite (gbuf, ncol, nbyte, stdout);
	fwrite (bbuf, ncol, nbyte, stdout);
	fflush (stdout);
	}

/* Free up malloced storage */
   free(bbuf);
   free(gbuf);
   free(rbuf);
   fclose(stdout);
   exit(0);
   }
