#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* Process data from an image via piping. Input can be any type */
/* Shift columns up or down by integer pixel amounts.  End-data is left
   untouched. */


int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   unsigned char *buf;

   int i, j, k;
   int cshift;

   if (argc != 5) {
	fprintf (stderr, "Usage: regcshift <nrow> <ncol> <nbyte> <cshift>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);
   cshift = atoi(argv[4]);

   if (nrow*ncol*nbyte == 0) exit(0);

   buf = malloc(ncol*nbyte);

   for (i=0; i<nrow; i++) {
	fread (buf, ncol, nbyte, stdin);
	if (cshift <= 0) {
	   for (j=0; j<ncol+cshift; j++) {
		for (k=0; k<nbyte; k++) {
		   buf[nbyte*j + k] = buf[nbyte*(j-cshift) + k];
		   }
		}
	} else {
	   for (j=ncol-1; j>=cshift; --j) {
		for (k=0; k<nbyte; k++) {
		   buf[nbyte*j + k] = buf[nbyte*(j-cshift) + k];
		   }
		}
	   }
	fwrite (buf, ncol, nbyte, stdout);
	fflush (stdout);
	}

/* Free up malloced storage */
   free(buf);
   fclose(stdout);
   exit(0);
   }
