#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/* Process data from an image via piping. Input must be unsigned int*/
/* Pass dimension information by argc mechanism; bytes come by stdin */
/* Return row median filtered over a specified interval */

static int compare(unsigned short *var1, unsigned short *var2) {
   if (*var1 < *var2) return -1;
   if (*var1 > *var2) return 1;
   return 0;
   }

int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   unsigned short *buf;
   unsigned short *buf2;
   unsigned short *sort;
   int interval;

   int i, j, k;

   if (argc != 7) {
	fprintf (stderr, "Usage: regSqrt <nrow> <ncol> <nbyte> <interval>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);
   interval = atof(argv[4]);

   if (nrow*ncol*nbyte == 0) exit(0);

   buf = (unsigned short *)malloc(ncol*sizeof(unsigned short));
   buf2 = (unsigned short *)malloc(ncol*sizeof(unsigned short));
   sort = (unsigned short *)malloc(interval*sizeof(unsigned short));

   for (i=0; i<nrow; i++) {
	fread (buf, 2*ncol, 1, stdin);
	for (j=interval/2; j<ncol-(interval+1)/2; j++) {
	   for (k=0; k<interval; k++) {
		sort[k] = buf[j-k-interval/2];
		}
	   qsort(sort, interval, nbyte, compare);
	   buf2[j] = sort[interval/2];
	   }
	for (j=interval/2; j<ncol-(interval+1)/2; j++) {
	   buf[j] = buf2[j];
	   }
	for (j=0; j<interval/2; j++) {
	   buf[j] = buf[interval/2];
	   }
	for (j=ncol-(interval+1)/2; j<ncol; j++) {
	   buf[j] = buf[ncol-(interval+1)/2 - 1];
	   }
	fwrite (buf, 2*ncol, 1, stdout);
	fflush (stdout);
	}

/* Free up malloced storage */
   free(buf);
   free(buf2);
   free(sort);
   fclose(stdout);
   exit(0);
   }
