#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/* Make a PPM file.  Inputs are bytes.
 */

int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   unsigned char *rbuf, *gbuf, *bbuf;
   unsigned char *outbuf;

   int i, j, ii, jj;
   unsigned char r,g,b;
   int nrep;
   FILE *file;

   if (argc != 6) {
	fprintf (stderr, "Usage: regPPM <nrow> <ncol> <nbyte> <rep>"
"<file>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);
   nrep = atoi(argv[4]);

   if (nrow*ncol*nbyte == 0) exit(0);

   file = fopen(argv[5], "w");
   fprintf (file, "P6 %d %d 255\n", ncol*nrep, nrow*nrep);   

   rbuf = (unsigned char *)malloc(ncol*sizeof(unsigned char));
   gbuf = (unsigned char *)malloc(ncol*sizeof(unsigned char));
   bbuf = (unsigned char *)malloc(ncol*sizeof(unsigned char));

   outbuf = (unsigned char *)malloc(ncol*nrep*3);

   for (i=0; i<nrow; i++) {
	fread (rbuf, ncol, 1, stdin);
	fread (gbuf, ncol, 1, stdin);
	fread (bbuf, ncol, 1, stdin);
	for (j=0; j<ncol; j++) {
          r = rbuf[j];
          g = gbuf[j];
          b = bbuf[j];
          for (jj=0; jj<nrep; jj++) {
	    outbuf[3*j*nrep + 3*jj + 0] = r;
	    outbuf[3*j*nrep + 3*jj + 1] = g;
	    outbuf[3*j*nrep + 3*jj + 2] = b;
	  }
	}
	for (ii=0; ii<nrep; ii++) {
	  fwrite (outbuf, ncol*nrep*3, 1, file);
	  fflush (file);
	}
   }

   fclose(file);

/* Free up malloced storage */
   free(bbuf);
   free(gbuf);
   free(rbuf);
   fclose(stdout);
   exit(0);
   }
