#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

/* Process data from an image via piping. Input must be unsigned int*/
/* Pass dimension information by argc mechanism; bytes come by stdin */
/* Return row median filtered over a specified interval */

/* Standard smoothing */

int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   unsigned short *buf1;
   unsigned short *buf2;
   unsigned short *buf3;
   unsigned short *bufout;

   int i, j;

   if (argc != 4) {
	fprintf (stderr, "Usage: regSmooth <nrow> <ncol> <nbyte>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);

   if (nrow*ncol*nbyte == 0) exit(0);

   buf1 = (unsigned short *)malloc((ncol+2)*sizeof(unsigned short));
   buf2 = (unsigned short *)malloc((ncol+2)*sizeof(unsigned short));
   buf3 = (unsigned short *)malloc((ncol+2)*sizeof(unsigned short));
   bufout = (unsigned short *)malloc(ncol*sizeof(unsigned short));

/* Make buffer ncol+2 wide.  Read 1st row and duplicate; then step through
 * remaining rows.
*/

/* buf1, 2, 3 have raw data, bufout has filtered data */
   fread (&buf3[1], 2*ncol, 1, stdin);
   buf3[0] = buf3[1];
   buf3[ncol+1] = buf3[ncol];
   memcpy (buf2, buf3, 2*(ncol+2));

   for (i=1; i<nrow; i++) {
	memcpy (buf1, buf2, 2*(ncol+2));
	memcpy (buf2, buf3, 2*(ncol+2));
	fread (&buf3[1], 2*ncol, 1, stdin);
	buf3[0] = buf3[1];
	buf3[ncol+1] = buf3[ncol];

	for (j=0; j<ncol; j++) {
	   bufout[j] = (4.*buf2[j+1] + buf2[j] + buf2[j+2] + \
		buf1[j+1] + buf3[j+1])/8.;
	   }
	fwrite (bufout, 2*ncol, 1, stdout);
	fflush (stdout);
	}

/* Need to compute last row */
   memcpy (buf1, buf2, 2*(ncol+2));
   memcpy (buf2, buf3, 2*(ncol+2));

   for (j=0; j<ncol; j++) {
	bufout[j] = (4.*buf2[j+1] + buf2[j] + buf2[j+2] + \
	   buf1[j+1] + buf3[j+1])/8.;
	}
   fwrite (bufout, 2*ncol, 1, stdout);
   fflush (stdout);

/* Free up malloced storage */
   free(buf1);
   free(buf2);
   free(buf3);
   free(bufout);
   fclose(stdout);
   return 0;
   }
