#include <stdio.h>
#include <math.h>
#include <stdlib.h>

/* Process data from an image via piping. Input must be short */
/* Pass dimension information by argc mechanism; bytes come by stdin */
/* Return image byte swapped */

int main(int argc, char **argv) {
   int nrow, ncol, nbyte;
   unsigned char *buf;
   unsigned char temp;

   int i, j;

   if (argc != 4) {
	fprintf (stderr, "Usage: regSqrt <nrow> <ncol> <nbyte>\n");
	exit(1);
	}

   nrow = atoi(argv[1]);
   ncol = atoi(argv[2]);
   nbyte = atoi(argv[3]);

   if (nrow*ncol*nbyte == 0) exit(0);

   buf = (unsigned char *)malloc(ncol*sizeof(unsigned short));

   for (i=0; i<nrow; i++) {
	fread (buf, 2*ncol, 1, stdin);
	for (j=0; j<ncol; j=j+2) {
	   temp=buf[j];
	   buf[j] = buf[j+1];
	   buf[j+1]=temp;
	   }
	fwrite (buf, 2*ncol, 1, stdout);
	fflush (stdout);
	}

/* Free up malloced storage */
   free(buf);
   fclose(stdout);
   exit(0);
   }
