/**************************************************************************
*                                                                         *
*  inverts a symmetric routine                                            *
*                                                                         *
**************************************************************************/
#include "math.h"

/* Return 1 for success, 0 for failure */

int syminv(double *a,
	double *b,
	int dimension,
	double *pvrow,
	double *pvcol,
	int *use)
{
register int i,j,h,k,l,m,n;
double dmax,diag;
double pvrwb=0.0,pivot=0.0;

  for(i=0;i<dimension;i++)
         *(use+i) = 0;
  
         

  for(n=0;n<dimension;n++)
       {
        dmax = 0.0;
        j=0;

        for(i=0 ;i<dimension; i++ ,j +=(i+1))
             {
              diag = fabs(*(a+j));    
              if((diag - dmax) <= 0.0) continue;
              if(*(use + i) >0) continue;

                 dmax = diag;
                 k = i;
                 pivot = *(a + j);

             }    
         

          if(dmax <= 0.0) {
                         /*   failure_exit(n,dimension); */
                            return 0;
                           }
          
             *(use+k) =1;
              l  = (k*(k+1))/2;


               for(i=0;i<dimension;i++)
                 {
                  if(i-k < 0)
                          {
                            *(pvrow + i )= *(a+l);
                            *(pvcol + i )= *(a+l)/pivot;
                            *(a + l)    = 0.0;
                              l +=1;

                           if( *(use +i) ==0) continue;
                           *(pvcol +i ) *=-1.0;
                           continue;
                           } 
                   if(i -k == 0)
                           {
                            *(pvrow + i) = 1.0;
                            *(pvcol + i) = -1.0/pivot;
                            *(a + l) = 0.0;
                            pvrwb = *(b+i);
                            l +=(i+1);
                            *(b+i) = 0.0;
                            continue;
                           } 
                           *(pvrow +i) = *(a + l);
                           *(pvcol +i) = *(a + l)/pivot;
                           *(a+l) = 0.0;
                           if( *(use +i) > 0) *(pvrow +i) *=-1;
                            l +=(i+1);
                   }

                 m = 0;

                 for(i=1;i<dimension+1; i++)
                     {
                      *(b+i-1)  -= pvrwb*(*(pvcol+i-1));

                       for(h=1;h<i+1;h++)
                           {
                             *(a+m) -= (*(pvcol+i-1)) *(*(pvrow+h-1));

                              m+=1;
                           }
                     }
             }

return 1;
}

