/* This is a template routine to be used to define new data types.  It is
** one of three modules that needs to be created for each data type.  Suppose
** you want to create a new data type called STAR.  Edit this file and
** make the following substitutions:
** foo_lc -> star
** Foo_mc -> Star
** FOO_uc -> STAR
** module_lc->ast
** MODULE_uc->AST
** The name of the module should be module_lcFOO_UC.c
** NOTE:::: This module is generic.
** I use this mechanism in order that it work with the EDT editor.
** Also, change the initialization pieces of code as appropriate */

/*****************************************************************************
******************************************************************************
**
** FILE:
**	module_lcFoo_mc.c
**
** ABSTRACT:
**	This file contains C routines to create and delete
**	FOO_UC structures.
**
** ENTRY POINT		SCOPE	DESCRIPTION
** -------------------------------------------------------------------------
** module_lcFoo_mcNew		public  Create a new FOO_UC
** module_lcFoo_mcDel		public	Delete a FOO_UC
**
** ENVIRONMENT:
**	ANSI C.
**
** REQUIRED PRODUCTS:
**	dervish
**	module_lc
**
** AUTHORS:
**	Creation date:  Oct, 1993
**	Steve Kent
**
******************************************************************************
******************************************************************************
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "shAssert.h"
#include "utils.h"	/* From Dervish */
#include "module_lcFoo_mc.h"
/*** Message codes ****/
#include "module_lc_msg_c.h"


/*============================================================================  
**============================================================================
**
** ROUTINE: module_lcFoo_mcNew
**
** DESCRIPTION:
**	Create a new FOO_UC
**
** RETURN VALUES:
**	Pointer to new structure, or NULL if failure
**
** CALLS TO:
**	shMalloc
**
**============================================================================
*/
foo_uc *
module_lcFoo_mcNew(void)
{
   FOO_uc *foo_lc = shMalloc(sizeof(FOO_uc));
/* Update here if more complicated allocation of storage is needed */
   foo_lc->type = shTypeGetFromName("FOO_UC");
   foo_lc->next = foo_lc->prev = NULL;
   foo_lc->name = NULL;
/* Replace this line as appropriate */
/*   foo_lc->f = foo_lc->i = foo_lc->l = 0; */
   return(foo_lc);
}


/*============================================================================  
**============================================================================
**
** ROUTINE: module_lcFoo_mcDel
**
** DESCRIPTION:
**	Delete a FOO_UC
**
** RETURN VALUES:
**	MODULE_UCSUCCESS	Success
**
** CALLS TO:
**	shFree
**
**============================================================================
*/
MODULE_uc_CODE
module_lcFoo_mcDel(FOO_uc *foo_lc)
{
   shAssert(foo_lc->next == NULL && foo_lc->prev == NULL);
   shFree(foo_lc);
   return(MODULE_uc_SUCCESS);
}
