proc fitslook {file} {
   set fname [ open $file ]
   set list {}
   while { [lvarpop list] != "END"} {
	set list [read $fname 80]
	echo $list
	}
   close $fname
   }

proc fitsDir {{dirList "*.fit *.fits"}} {
   set list [eval glob $dirList]
   echo [format "%-15s %-10s %-10s %-10s %-3s" File Date UT Object Fil]

   set hdr [hdrNew]
   foreach file $list {
        hdrReadAsFits $hdr $file
        set date ""; set filter ""; set object ""; set ut "";
        catch {set date [hdrGetAsAscii $hdr DATE-OBS]}
        catch {set filter [hdrGetAsAscii $hdr FILTER]}
        catch {set object [hdrGetAsAscii $hdr OBJECT]}
        catch {set ut [hdrGetAsAscii $hdr TAI]}
        catch {set ut [hdrGetAsAscii $hdr TAI_OBS]}
        catch {set ut [hdrGetAsAscii $hdr UT]}
	set file [string range $file 0 14]
	set date [string range $date 0 9]
	set ut [string range $ut 0 9]
	set object [string range $object 0 9]
	set filter [string range $filter 0 2]
        echo [format "%-15s %-10s %-10s %-10s %-3s" $file $date $ut $object $filter]
        }
   hdrDel $hdr
   handleDel $hdr
   }
