proc listcom {{pattern "*"}} {
   set comlist [info commands $pattern]
   set newcomlist [lsort $comlist]
   while {$newcomlist != ""} {
	set line ""
	for {set i 0} {$i < 3} {incr i} {
	   if {$newcomlist == ""} break
	   set command [lvarpop newcomlist]
	   append line [format "%-26s" $command]
	   }
	echo $line
	}
   }

proc listvar {{pattern "*"}} {
   set comlist [info global $pattern]
   set newcomlist [lsort $comlist]
   while {$newcomlist != ""} {
	set line ""
	for {set i 0} {$i < 5} {incr i} {
	   if {$newcomlist == ""} break
	   set command [lvarpop newcomlist]
	   append line [format "%-16s" $command]
	   }
	echo $line
	}
   }

proc listarr {{pattern "*"}} {
   set comlist [info global $pattern]
   set newcomlist [lsort $comlist]
   while {$newcomlist != ""} {
	set line ""
	set k 0
	while {$newcomlist != ""} {
	   set command [lvarpop newcomlist]
	   set cmd "if \{!\[array exists $command\]\} continue"
	   uplevel #0 $cmd
	   append line [format "%-16s" $command]
	   incr k
	   if {$k == 5} break
	   }
	if {$line != ""} {echo $line}
	}
   }

proc printvar {{pattern "*"}} {
   set comlist [info global $pattern]
   set newcomlist [lsort $comlist]
   while {$newcomlist != ""} {
	set var [lvarpop newcomlist]
	global $var
	set err [catch {array names $var}]
	if {$err == 0} then {
	   set names [lsort [array names $var]]
	   foreach name $names {
		echo ${var}($name) [set ${var}($name)]
		}
	} else {
	   echo $var [set $var]
	   }
	}
   }

proc listarray {array} {
   global $array
   set comlist [array names $array]
   set newcomlist [lsort $comlist]
   while {$newcomlist != ""} {
	set line ""
	for {set i 0} {$i < 5} {incr i} {
	   if {$newcomlist == ""} break
	   set command [lvarpop newcomlist]
	   append line [format "%-16s" $command]
	   }
	echo $line
	}
   }

proc typesPrint {} {
   set comlist [typesList]
   set newcomlist [lsort $comlist]
   while {$newcomlist != ""} {
	set line ""
	for {set i 0} {$i < 4} {incr i} {
	   if {$newcomlist == ""} break
	   set command [lvarpop newcomlist]
	   append line [format "%-19s" $command]
	   }
	echo $line
	}
   }

proc listproc {{pattern "*"}} {
   set comlist [info proc $pattern]
   set newcomlist [lsort $comlist]
   while {$newcomlist != ""} {
	set line ""
	for {set i 0} {$i < 3} {incr i} {
	   if {$newcomlist == ""} break
	   set command [lvarpop newcomlist]
	   append line [format "%-26s" $command]
	   }
	echo $line
	}
   }
