proc pgSym {val} {
   global pgSym
   set pgSym $val
   }

proc rmin {reg row col1 col2} {
   set low 65535
   for {set i $col1} {$i < $col2} {incr i} {
	set p [regPixGet $reg $row $i]
	if {[expr {$p < $low}]} then {set low $p} else {}
	}
   set low
   }

proc rmax {reg row col1 col2} {
   set high -65536
   for {set i $col1} {$i < $col2} {incr i} {
	set p [regPixGet $reg $row $i]
	if {[expr {$p > $high}]} then {set high $p} else {}
	}
   set high
   }

proc plotrow {reg row col1 col2  {ymin ""} {ymax ""} {new "NEW"} } {
   set low [rmin $reg $row $col1 $col2]
   set high [rmax $reg $row $col1 $col2]
   set diff [expr {$high - $low}]
   set low [expr {$low - 0.1 * $diff}]
   set high [expr {$high + 0.1 * $diff}]
   if {$ymin == ""} then {set ymin $low} else {}
   if {$ymax == ""} then {set ymax $high} else {}
   if {$new == "NEW"} then {
	pgEnv $col1 $col2 $ymin $ymax 0 0
	pgSls 1 } else {
	pgWindow $col1 $col2 $ymin $ymax
	pgSls 2 }
   for {set i $col1 } {$i < $col2} {incr i} {
	set p [regPixGet $reg $row $i]
	pgDraw $i $p
	}
   }

proc overplotrow {reg row col1 col2} {
   set pgSLS 2
   pgMove $col1 [regPixGet $reg $row $col1]
   for {set i $col1 } {$i < $col2} {incr i} {
	set p [regPixGet $reg $row $i]
	pgDraw $i $p
	}
   }

proc cmin {reg col row1 row2} {
   set low 65535
   for {set i $row1} {$i < $row2} {incr i} {
	set p [regPixGet $reg $i $col]
	if {[expr {$p < $low}]} then {set low $p} else {}
	}
   set low
   }

proc cmax {reg col row1 row2} {
   set high -65536
   for {set i $row1} {$i < $row2} {incr i} {
	set p [regPixGet $reg $i $col]
	if {[expr {$p > $high}]} then {set high $p} else {}
	}
   set high
   }

proc plotcol {reg col row1 row2 {ymin ""} {ymax ""} {new "NEW"} } {
   set low [cmin $reg $col $row1 $row2]
   set high [cmax $reg $col $row1 $row2]
   set diff [expr {$high - $low}]
   set low [expr {$low - 0.1 * $diff}]
   set high [expr {$high + 0.1 * $diff}]
   if {$ymin == ""} then {set ymin $low} else {}
   if {$ymax == ""} then {set ymax $high} else {}
   set pgSLS 1
   if {$new == "NEW"} then {
	pgEnv $row1 $row2 $ymin $ymax 0 0
	pgSls 1 } else {
	pgWindow $row1 $row2 $ymin $ymax
	pgSls 2 }
   for {set i $row1 } {$i < $row2} {incr i} {
	set p [regPixGet $reg $i $col]
	pgDraw $i $p
	}
   }

proc overplotcol {reg col row1 row2} {
   set pgSLS 2
   pgMove $row1 [regPixGet $reg $row1 $col]
   for {set i $row1 } {$i < $row2} {incr i} {
	set p [regPixGet $reg $i $col]
	pgDraw $i $p
	}
   }

##################################################################
#plotInit is designed for use with both X and file based output.  If
#file based, just call pgPage.  This is handy if one wants to tailor
#the output page with more than just pgEnv

proc plotInit {} {
   if {[pgQinf STATE] != "OPEN"} {
        pgBegin
        pgGeomSet 400 400 10 25
        pgUpdt
        pgAsk 0
        pgPage
   } else {
        if {[pgQinf file] == ""} {
           pgPage
           }
        }
   pgSch 1
   pgSci 1
   return
   }

#Suggest use of above.
#   pgWindow xmin xmax ymin ymax
#   pgBox

