#Create, edit, and source procs internal to shiva
#This is for quick on-the-fly functions
proc procEdit {inproc} {
   set procName proc_$inproc
   global $procName
   if {[info proc $inproc] == ""} then {
	set [set procName](0) $inproc
	loop i 1 50 {
	   set [set procName]($i) ""
	   }
   } else {
	catch {unset $procName}
	set args [info args $inproc]
	set arglist ""
	foreach arg $args {
	   if {[info default $inproc $arg def]} then {
		lappend arglist "$arg $def"
	   } else {
		lappend arglist $arg
		}
	   }
	set [set procName](0) $inproc
	set [set procName](1) "proc $inproc [list $arglist] \{"
	set body [info body $inproc]
	set body [split $body \n]
	set index 2
	loop i 0 [llength $body] {
	   set line [string trimright [lindex $body $i] " \r"]
	   if {[regexp  "^(\ )*$" $line]} then continue
	   set [set procName]($index) $line
	   incr index
	   }
	set [set procName]($index) "\}"
	incr index
	set array($index) ""
	}
   set begin 1
   while {1} {
	set flags [screenEdit "Tcl Procedure $inproc" $begin $procName 80]
	if {[lindex $flags 0] == "B"} then return
	if {[lindex $flags 0] == "I"} then {
#insert line
	   set i [lindex $flags 1]
	   for {set j [array size $procName]} {$j > $i} {incr j -1} {
		set [set procName]($j) [set [set procName]([expr $j-1])]
		}
	   set [set procName]($i) ""
	   set begin $i
	   continue
	   }
	if {[lindex $flags 0] == "W"} then {
#insert line
	   set i [lindex $flags 1]
	   for {set j $i} {$j < [expr [array size $procName]-1]} {incr j} {
		set [set procName]($j) [set [set procName]([expr $j+1])]
		}
	   unset [set procName]([expr [array size $procName]-1])
	   set begin $i
	   continue
	   }
	if {[lindex $flags 0] == "X"} then continue
	break
	}
   procSource $inproc
   procSave $inproc
   return
   }

##########################################################################
proc procSource {inproc} {
   set procName proc_$inproc
   global $procName
   if {![info exists $procName]} then {
	error "Procedure $inproc does not exist"
	}
   set line ""
   loop i 1 [array size $procName] {
	set elem [set [set procName]($i)]
	if {$elem == ""} then continue
	append line $elem "\r\n"
	}
   eval $line
   return
   }

##########################################################################
#Save one of the above procedures to a file
proc procSave {inproc} {
   set procName proc_$inproc
   global $procName TCL_SAVE
   if {[info exists TCL_SAVE]} then {set dir $TCL_SAVE} else {set dir .}
   set fid [open $dir/${inproc}.tcl w]
   loop i 1 [array size $procName] {
      if {[set [set procName]($i)] != ""} then {
         puts $fid [set [set procName]($i)]
         }
      }
   close $fid
   }
##########################################################################
#Delete one of the above procedures
proc procDel {inproc} {
   set procName proc_$inproc
   global $procName TCL_SAVE
   if {[info exists TCL_SAVE]} then {set dir $TCL_SAVE} else {set dir .}
   set file $dir/$inproc.tcl
   if {[file exists $file]} then {exec rm $file}
   if {[info exists proc_$inproc]} then {unset proc_$inproc}
   if {[info command $inproc] != ""} then {rename $inproc ""}
   }
