##
# utilities for printing and plotting residuals
#
proc domore {{flag 1}} {
   global more_counter
   if {$flag == 0} then {
	set more_counter 0;
	return 0}
   incr more_counter
   if {$more_counter < 20} then {return 0} else {}
   puts stdout "<CR> or q: " nonewline
   gets stdin yn
   if {$yn == "q"} then {return 1}
   set more_counter 0;
   return 0
   }

proc cplot {handle xtype ytype args} {
   global pgSym
   if { [pgQinf STATE] == "CLOSED"} then {pgBegin; pgAsk 0}
   if { [info exists pgSym]} then {set sym $pgSym} else {set sym 1}
   set xmin 1.e10; set xmax -1.e10; set ymin 1.e10; set ymax -1.e10
   set i 0
   if {[lsearch $args y] != -1} then {set overlay y} else {set overlay n}
   if {$overlay == "n" || [lsearch $args -rescale] != -1} then {
	set iterator [chainCursorNew $handle]
	set hand [chainWalk $handle $iterator]
	while {$hand != ""} {
	   if {$xtype != "#i"} then {
		set x [exprGet "$hand.$xtype"]
	   } else {
		set x $i
		}
	   incr i
	   set y [exprGet "$hand.$ytype"]
	   set xmin [min $xmin $x ]
	   set ymin [min $ymin $y ]
	   set xmax [max $x $xmax ]
	   set ymax [max $y $ymax ]
	   handleDel $hand
	   set hand [chainWalk $handle $iterator]
	   }
	chainCursorDel $handle $iterator
	set xmin [expr {$xmin - ($xmax-$xmin)*.05} ]
	set xmax [expr {$xmax + ($xmax-$xmin)*.05} ]
	set ymin [expr {$ymin - ($ymax-$ymin)*.05} ]
	set ymax [expr {$ymax + ($ymax-$ymin)*.05} ]
	pgWindow $xmin $xmax $ymin $ymax
	}
#   pgSlw 3
   pgSch 1.2
   global XMIN XMAX YMIN YMAX
	if {[info exists XMIN]} {set xmin $XMIN}
	if {[info exists XMAX]} {set xmax $XMAX}
	if {[info exists YMIN]} {set ymin $YMIN}
	if {[info exists YMAX]} {set ymax $YMAX}
   if {$overlay == "n"} then {pgEnv $xmin $xmax $ymin $ymax 0 0}
   pgLabel "$xtype" "$ytype" ""
   set iterator [chainCursorNew $handle]
   set hand [chainWalk $handle $iterator]
   set i 0
   while {$hand != ""} {
	if {$xtype != "#i"} then {
	   set x [exprGet "$hand.$xtype"]
	} else {
	   set x $i
	   }
	incr i
	set y [exprGet "$hand.$ytype"]
	pgPoint $x $y $sym
	handleDel $hand
	set hand [chainWalk $handle $iterator]
	}
   chainCursorDel $handle $iterator
   }

proc chainPlot {chain xvar yvar {overlay n}} {
   global pgstate
   global pgSym
   if {![info exists pgstate]} then {
	set pgstate [pgstateNew]
	pgstateOpen $pgstate
	}
   if { [info exists pgSym]} then {set sym $pgSym} else {set sym 1}
   pgstateSet $pgstate -symb $sym
   set newplt 1
   if {$overlay != "n"} then {set newplt 0}
   pgstateSet $pgstate -isNewplot $newplt
   set color [pgQci]
   pgstateSet $pgstate -icMark $color
   pgstateSet $pgstate -icLine $color
   pgstateSet $pgstate -icBox $color
   pgstateSet $pgstate -icLabel $color
   pgstateSet $pgstate -icError $color
   set af1 [afFromChain $chain $xvar]
   set af2 [afFromChain $chain $yvar]
   afPlot $pgstate $af1 $af2
   afDel $af1
   afDel $af2
   }

proc clabel {handle xtype ytype labtype {overlay n}} {
   upvar 1 pgSym pgSym
   if { [pgQinf STATE] == "CLOSED"} then {pgBegin; pgAsk 0}
   if { [info exists pgSym]} then {set sym $pgSym} else {set sym 1}
   set iterator [chainCursorNew $handle]
   set hand [chainWalk $handle $iterator]
   set xmin 1.e10; set xmax -1.e10; set ymin 1.e10; set ymax -1.e10
   set i 0
   if {$overlay == "n"} then {
	while {$hand != ""} {
	   if {$xtype != "#i"} then {
		set x [exprGet "$hand.$xtype"]
	   } else {
		set x $i
		}
	   incr i
	   set y [exprGet "$hand.$ytype"]
	   set xmin [min $xmin $x ]
	   set ymin [min $ymin $y ]
	   set xmax [max $x $xmax ]
	   set ymax [max $y $ymax ]
	   handleDel $hand
	   set hand [chainWalk $handle $iterator]
	   }
	chainCursorDel $handle $iterator
	set xmin [expr {$xmin - ($xmax-$xmin)*.05} ]
	set xmax [expr {$xmax + ($xmax-$xmin)*.05} ]
	set ymin [expr {$ymin - ($ymax-$ymin)*.05} ]
	set ymax [expr {$ymax + ($ymax-$ymin)*.05} ]
	}
#   pgSlw 3
   pgSch 1.2
   if {$overlay == "n"} then {pgEnv $xmin $xmax $ymin $ymax 0 0}
   pgLabel "$xtype" "$ytype" ""
   set iterator [chainCursorNew $handle]
   set hand [chainWalk $handle $iterator]
   set i 0
   while {$hand != ""} {
	if {$xtype != "#i"} then {
	   set x [exprGet "$hand.$xtype"]
	} else {
	   set x $i
	   }
	incr i
	set y [exprGet "$hand.$ytype"]
	set sym [exprGet $hand.$labtype]
	pgText $x $y $sym
	handleDel $hand
	set hand [chainWalk $handle $iterator]
	}
   chainCursorDel $handle $iterator
   }

