/*                                                          f_hdel
------------------------------------------------------------------

Synopsis:       #include "libfits.h"
                int f_hdel(header)
                char *header[];

Purpose:        Delete all lines from the header

Inputs:         'header' is the file header

Returns:        TRUE on success,
                FALSE on failure

History:        1993 December 3, Tom Nicinski, Fermilab

------------------------------------------------------------------

*/

#include "libfits.h"

int f_hdel(char **header)
{

        int     hlines;         /* number of header lines               */
        extern int f_debug(int flag);   /* error messages on or off             */

        if (header == 0) {
                return (TRUE);		/* no header vector             */
                }

        for (hlines = 0; header[hlines] != NULL; hlines++) {
                shFree(header[hlines]);
                header[hlines] = NULL;
                }

        return(TRUE);

}

#ifdef DEBUG    /* passed this test August 7, 1986 */

#define HEADERSIZE (36 * 2)

main(argc, argv)
int argc;
char *argv[];

{


        int line;
        char *header[HEADERSIZE];
        FILE *fp, *f_rdfits();
        extern void f_init();
        extern int f_debug(), f_hdel();

        if (argc != 2) {
                printf("usage: f_hdel input\n");
                exit(1);
        }

        f_setup();
        f_debug(TRUE);

        if ((fp = f_rdfits(argv[1], header, HEADERSIZE)) == NULL) {
                printf("Can't open %s\n", argv[1]);
                exit(1);
        }

        prhead(header);
        if (! f_hdel(header, line)) {
                printf("f_hdel: error deleting all lines\n");
        }
        else {
                prhead(header);
        }
}

void prhead(header)
char *header[];

{

        register int i, j;
        char line[80];


        for (i = 0; header[i] != NULL; i++) {
                for (j = 0; j < 80; j++) {
                        line[j] = header[i][j];
                }
                for (j = 79; j >= 0; j--) {
                        if (line[j] != ' ')
                                break;
                }
                line[j+1] = '\0';
                printf("%2d: %s\n", i, line);
        }
}

#endif /* DEBUG */
