#!/bin/sh
#
# $Source: /cvs/sdss/sdsstools/bin/isSciLinux.sh,v $
# $Revision: 1.2 $    Last Modified: $Date: 2006/07/20 00:13:16 $
#
#   prints TRUE  and exits 0 when the glibc is >= 2.3.2
#   prints FALSE and exits 1 for earlier glibc versions
#

##
# Use the compiled glibcVersion (but its not made when
# cutting sdsstools)!  Thus fall-back to a not-so-perfect method.
##
versPgm=`which glibcVersion 2> /dev/null`
exitCode=$?
if [ $exitCode -ne 0 -o -z "$versPgm" ]
then
    ##
    # glibcVersion not found, see if its in the 'current' sdsstools product
    ##
    tDir="`ups list -cK+:@PROD_DIR sdsstools | awk '{pdir=$NF;gsub(/\"/,"",pdir);print pdir}'`"
    for pDir in $tDir
    do
	if [ -e $pDir/bin/glibcVersion ]
	then
	    versPgm=$pDir/bin/glibcVersion
	    break
	fi
    done
fi
if [ -z "$versPgm" ]
then
    ##
    # Still not found -- query the rpms
    # This is NOT the primary means as its possible to have
    # multiple glibc rpms installed.  That is why the C program is
    # preferred as it always outputs the actual glibc in use.
    ##
    hwType=`uname -i`  # e.g. i386, x86_64
    if [ "$hwType" = x86_64 ]
    then
	ckVers=glibc.$hwType
    else
	ckVers=glibc
    fi
    versNum=`rpm -qi $ckVers | awk '$1 ~ /^Version/ {print $3}'`
else
    # Use the C program
    versNum=`$versPgm`     # EG: 2.3.4
fi
versPart_1="`echo $versNum | cut -d. -f1`" # EG: 2
versPart_2="`echo $versNum | cut -d. -f2`" # EG: 3
versPart_3="`echo $versNum | cut -d. -f3`" # EG: 4


#echo -e "versStr=${versStr[@]}"

if [ $versPart_1 -lt 2 ]
then
    ans=FALSE
elif [ $versPart_1 -gt 2 ]
then
    ans=TRUE
else
    # First version number is 2, test 2nd number
    if [ $versPart_2 -lt 3 ]
    then
	ans=FALSE
    elif [ $versPart_2 -gt 3 ]
    then
	ans=TRUE
    else
	# 2nd version number is 3, test 3rd number
	if [ $versPart_3 -lt 2 ]
	then
	    ans=FALSE
	else
	    ans=TRUE
	fi
    fi
fi
echo -e "$ans"
if [ $ans = TRUE ]
then
    retVal=0
else
    retVal=1
fi
exit $retVal
